unit main;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  StdCtrls, OKAPI32, SetSeqN, BufferDlg, SetLBuffer, Signal, About, SetSNum, SetCNum,
  SetSize, Select, LConvEncoding;

type

  { TmainFrm }

  TmainFrm = class(TForm)
    cnMenu: TMainMenu;
    FileMenu: TMenuItem;
    ODlg: TOpenDialog;
    OpenDlg: TOpenDialog;
    M2VSaveDlg: TSaveDialog;
    SaveDlg: TSaveDialog;
    SDlg: TSaveDialog;
    ZeroAllBuffer: TMenuItem;
    SaveScreen: TMenuItem;
    AbsoluteLut: TMenuItem;
    AbsoluteDsa: TMenuItem;
    TestVGACard: TMenuItem;
    TestDrawWnd: TMenuItem;
    TestMainWnd: TMenuItem;
    MenuItem105: TMenuItem;
    DisableActive: TMenuItem;
    DisableSyncVert: TMenuItem;
    MenuItem108: TMenuItem;
    SetAllocBuf: TMenuItem;
    SaveBuffer: TMenuItem;
    LockBufSize: TMenuItem;
    RegDevDriver: TMenuItem;
    MenuItem112: TMenuItem;
    SignalInfo: TMenuItem;
    ExtTrigger: TMenuItem;
    AboutMenu: TMenuItem;
    MenuItem12: TMenuItem;
    CopyToClipb: TMenuItem;
    MenuItem14: TMenuItem;
    SetToZero: TMenuItem;
    SetToBand: TMenuItem;
    MenuItem17: TMenuItem;
    PrintPic: TMenuItem;
    MenuItem19: TMenuItem;
    OptionMenu: TMenuItem;
    LoadConfigFile: TMenuItem;
    SaveConfigFile: TMenuItem;
    MenuItem22: TMenuItem;
    PrgExit: TMenuItem;
    SetupVideo: TMenuItem;
    CapSequence: TMenuItem;
    FillInGLut: TMenuItem;
    MenuItem27: TMenuItem;
    CenterScreen: TMenuItem;
    EnableMask: TMenuItem;
    CaptureMenu: TMenuItem;
    MenuItem30: TMenuItem;
    MakeXMirror: TMenuItem;
    MakeYMirror: TMenuItem;
    UpToRight: TMenuItem;
    UpToLeft: TMenuItem;
    MenuItem35: TMenuItem;
    NormaInLut: TMenuItem;
    InverseInLut: TMenuItem;
    MenuItem38: TMenuItem;
    MatchClient: TMenuItem;
    DispMenu: TMenuItem;
    SetMatchSize: TMenuItem;
    MenuItem41: TMenuItem;
    ReplayBuffer: TMenuItem;
    ReplayMemory: TMenuItem;
    ReplayFile: TMenuItem;
    MenuItem45: TMenuItem;
    BufferToScreen: TMenuItem;
    ScreenToBuffer: TMenuItem;
    Buffer0ToBuffer1: TMenuItem;
    Buffer1ToBuffer0: TMenuItem;
    Freeze: TMenuItem;
    MenuItem50: TMenuItem;
    BufferToFrame: TMenuItem;
    FrameToBuffer: TMenuItem;
    FrameToScreen: TMenuItem;
    MenuItem54: TMenuItem;
    SelectCard: TMenuItem;
    BackToScreen: TMenuItem;
    MenuItem57: TMenuItem;
    CapToBuffer: TMenuItem;
    LoopToBuffer: TMenuItem;
    LazActive: TMenuItem;
    MenuItem60: TMenuItem;
    SeqCapToBuf: TMenuItem;
    LoopSeqCapToBuf: TMenuItem;
    MenuItem63: TMenuItem;
    CapToMemory: TMenuItem;
    CapToSeqfile: TMenuItem;
    MenuItem66: TMenuItem;
    CapToInDirect: TMenuItem;
    InterToIndirect: TMenuItem;
    CapToPseudo: TMenuItem;
    SingleCapTo: TMenuItem;
    MenuItem70: TMenuItem;
    CapToDirect: TMenuItem;
    CapToForever: TMenuItem;
    MenuItem73: TMenuItem;
    ContToBuffer0: TMenuItem;
    ContToBuffer1: TMenuItem;
    MenuItem76: TMenuItem;
    CapToFrame: TMenuItem;
    MenuItem78: TMenuItem;
    MulChanCap: TMenuItem;
    HelpMenu: TMenuItem;
    MulChanCapSub: TMenuItem;
    MenuItem81: TMenuItem;
    AsyncMulCap: TMenuItem;
    SyncMulCap: TMenuItem;
    MenuItem84: TMenuItem;
    CaptureAudio: TMenuItem;
    MenuItem86: TMenuItem;
    CaptureMpeg2: TMenuItem;
    DispFromBuffer: TMenuItem;
    LoopFromBuffer: TMenuItem;
    LoadFile: TMenuItem;
    InterFromBuffer: TMenuItem;
    MenuItem91: TMenuItem;
    DispFromMemory: TMenuItem;
    DispFromFile: TMenuItem;
    MenuItem94: TMenuItem;
    CapToMonitor: TMenuItem;
    DispFromFrame: TMenuItem;
    MenuItem97: TMenuItem;
    NormalLut: TMenuItem;
    InverseLut: TMenuItem;
    procedure AboutMenuClick(Sender: TObject);
    procedure AbsoluteDsaClick(Sender: TObject);
    procedure AbsoluteLutClick(Sender: TObject);
    procedure AsyncMulCapClick(Sender: TObject);
    procedure BackToScreenClick(Sender: TObject);
    procedure Buffer0ToBuffer1Click(Sender: TObject);
    procedure Buffer1ToBuffer0Click(Sender: TObject);
    procedure BufferToFrameClick(Sender: TObject);
    procedure BufferToScreenClick(Sender: TObject);
    procedure CapSequenceClick(Sender: TObject);
    procedure CapToBufferClick(Sender: TObject);
    procedure CapToDirectClick(Sender: TObject);
    procedure CapToForeverClick(Sender: TObject);
    procedure CapToFrameClick(Sender: TObject);
    procedure CapToInDirectClick(Sender: TObject);
    procedure CapToMemoryClick(Sender: TObject);
    procedure CapToMonitorClick(Sender: TObject);
    procedure CapToPseudoClick(Sender: TObject);
    procedure CapToSeqfileClick(Sender: TObject);
    procedure CaptureAudioClick(Sender: TObject);
    procedure CaptureMpeg2Click(Sender: TObject);
    procedure CenterScreenClick(Sender: TObject);
    procedure ContToBuffer0Click(Sender: TObject);
    procedure ContToBuffer1Click(Sender: TObject);
    procedure CopyToClipbClick(Sender: TObject);
    procedure DisableActiveClick(Sender: TObject);
    procedure DisableSyncVertClick(Sender: TObject);
    procedure DispFromBufferClick(Sender: TObject);
    procedure DispFromFileClick(Sender: TObject);
    procedure DispFromFrameClick(Sender: TObject);
    procedure DispFromMemoryClick(Sender: TObject);
    procedure EnableMaskClick(Sender: TObject);
    procedure ExtTriggerClick(Sender: TObject);
    procedure FillInGLutClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FrameToBufferClick(Sender: TObject);
    procedure FrameToScreenClick(Sender: TObject);
    procedure FreezeClick(Sender: TObject);
    procedure InterFromBufferClick(Sender: TObject);
    procedure InterToIndirectClick(Sender: TObject);
    procedure InverseInLutClick(Sender: TObject);
    procedure InverseLutClick(Sender: TObject);
    procedure LazActiveClick(Sender: TObject);
    procedure LoadConfigFileClick(Sender: TObject);
    procedure LoadFileClick(Sender: TObject);
    procedure LockBufSizeClick(Sender: TObject);
    procedure LoopFromBufferClick(Sender: TObject);
    procedure LoopSeqCapToBufClick(Sender: TObject);
    procedure LoopToBufferClick(Sender: TObject);
    procedure MakeXMirrorClick(Sender: TObject);
    procedure MakeYMirrorClick(Sender: TObject);
    procedure MatchClientClick(Sender: TObject);
    procedure MulChanCapClick(Sender: TObject);
    procedure MulChanCapSubClick(Sender: TObject);
    procedure NormaInLutClick(Sender: TObject);
    procedure NormalLutClick(Sender: TObject);
    procedure PrgExitClick(Sender: TObject);
    procedure PrintPicClick(Sender: TObject);
    procedure RegDevDriverClick(Sender: TObject);
    procedure ReplayBufferClick(Sender: TObject);
    procedure ReplayFileClick(Sender: TObject);
    procedure ReplayMemoryClick(Sender: TObject);
    procedure SaveBufferClick(Sender: TObject);
    procedure SaveConfigFileClick(Sender: TObject);
    procedure SaveScreenClick(Sender: TObject);
    procedure ScreenToBufferClick(Sender: TObject);
    procedure SelectCardClick(Sender: TObject);
    procedure SeqCapToBufClick(Sender: TObject);
    procedure SetAllocBufClick(Sender: TObject);
    procedure SetMatchSizeClick(Sender: TObject);
    procedure SetToBandClick(Sender: TObject);
    procedure SetToZeroClick(Sender: TObject);
    procedure SetupVideoClick(Sender: TObject);
    procedure SignalInfoClick(Sender: TObject);
    procedure SingleCapToClick(Sender: TObject);
    procedure SyncMulCapClick(Sender: TObject);
    procedure TestDrawWndClick(Sender: TObject);
    procedure TestMainWndClick(Sender: TObject);
    procedure TestVGACardClick(Sender: TObject);
    procedure UpToLeftClick(Sender: TObject);
    procedure UpToRightClick(Sender: TObject);
    procedure ZeroAllBufferClick(Sender: TObject);

  private
    { private declarations }
    function exGetFrameSize(hBoard:HWND):Longint;

    function exGetInitSet:Boolean;
    procedure exSaveInitSet;

    function InitSetMenu(hBoard:HWND):Boolean;

    function exSetToWndRectEx(hBoard:HWND; dhWnd:HWND; lMode:Boolean):Longint;
    function exGetBitmapHeader(hBoard:HWND; src:TARGET; lpbi:PBITMAPINFOHEADER):Boolean;

    function exSetTestBands(lpLinear:Pointer; bits:Smallint; hei:Smallint; stride:Longint):Boolean;

    function exCaptureStreamFile(hBoard:HWND; thWnd:HWND):Boolean;

    function exStopMulCapture:Integer;
    procedure exCloseThisBoard(hBoard:HWND);

{    procedure WMSize(var Msg:Tmessage);message WM_SIZE;
    procedure WMSizing(var Msg:Tmessage);message WM_SIZING;
    procedure WMMove(var Msg: Tmessage);message WM_MOVE;
    procedure WMMoving(var Msg: Tmessage);message WM_MOVING;
    procedure OnAskWaitVertical(var Msg:Tmessage);message WM_ASKWAITVERTICAL;}
  public
    { public declarations }
    function exOpenCard(dlhWnd:HWND):HWND;
    procedure exSetPaletteToWnd(dlhDC:HWND);
    function exMakeLogPalette(iBits:Smallint; rgbForm:Smallint):HPALETTE;
    function exLoadImageFile(hBoard:HWND;dlhWnd:HWND):Boolean;
    procedure exSaveScreenFile(hBoard:HWND);
    procedure exSaveBufferFile(hBoard:HWND);
  end;

type
    _wavfileheader = Record
	RIFF:Array [0..3] of char;
	lFileLength:Longint;
	WAVE:Array [0..3] of char;
	fmt:Array [0..3] of char;
	lHeadSize:Longint;

	//PCMWAVEFORMAT pcmheader;
	wFormatTag:WORD;
	nChannels:WORD;
	nSamplesPerSec:DWORD;
	nAvgBytesPerSec:DWORD;
	nBlockAlign:WORD;
	wBitsPerSample:WORD;
	data: Array [0..3] of char;
	lDataLength:Longint;
end;

type
    LPWORD = ^WORD;
    NPLOGPALETTE = ^LOGPALETTE;
    WAVEFILEHEADER = _wavfileheader;


  function exGetBitmapData(hBoard:HWND; src:TARGET; start:Integer; lpbi:PBITMAPINFOHEADER; var lpdib:LPSTR):Longint;
  procedure exDisplayDIBInfo();
  function exConvertBitmap(lpbi:PBITMAPINFOHEADER;lpdib:LPSTR):Boolean;
  function exSetBitmapHeader(lpbi:PBITMAPINFOHEADER;width:Smallint;height:Smallint;bits:Smallint;form:Smallint):Longint;

  //CallBack Define
  function exBeginCapture(hBoard:HWND):Boolean;stdcall;
  function exBackDisplay(hBoard:HWND;no:Longint):Boolean;stdcall;
  function exSetToScreen(hBoard:HWND;no:Longint):Boolean;stdcall;
  function exEndCapture(hBoard:HWND):Boolean;stdcall;

  //--extra
  function exDemoMask(hBoard:HWND; bMaskMode:Smallint):Boolean;
  function exFillOutLUT(hBoard:HWND;index:Smallint):Boolean;
  function exFillInputLUT(hBoard:HWND;index:Smallint):Boolean;

  //----local functions-------------------------------------

  function exSetDataToDIB(src:TARGET; start:Smallint; lpbi:PBITMAPINFOHEADER; lpdib:LPBYTE):Longint;
  function exGetTargetSize(hBoard:HWND; tgt:TARGET; var width:Smallint; var height:Smallint):Longint;
  procedure exCreateAudioFile2(hAudio:HWND; szFileName:LPSTR; lSampFrq:Longint; iSampBits:Smallint);


  //Audio part
  function  exWriteAudioData(hAudio:HWND; var lpAudBuf:BYTE; length:Longint):Boolean;stdcall;
  {function exDrawAudio(hAudio:HWND; lpwAudio:Pointer; size:Longint):Boolean;stdcall;
}
  function exCalcCaptureRatio:Single;

  function exAllocateDIBMemory(lExpectSize:Longint):Longint;

  function exCreateStreamFile3(hStream:HWND; szFileName:LPSTR):Boolean;
  function exEndCaptureStream(hStream:HWND):Boolean;
  function exMsgCallback(hStream:HWND; lpStreamBuf:LPBYTE; length:Longint):Boolean;stdcall;
  {function exWriteStreamData(hStream:HWND; lpStreamBuf:LPBYTE; length:Longint):Boolean;
  function exCreateStreamFile1(hAudio:HWND; szFileName:LPSTR):Boolean;
  function exCreateStreamFile2(hStream:HWND; szFileName:LPSTR):Boolean;
                                                                       }
  function exCreateLoopCapture(hBoard:HWND; dlhWnd:HWND):HWND;
  function CaptureOneByOne(dlhWnd:HWND):LRESULT;
  function DrawToWndDC(dlhWnd:HWND; hBoard:HWND; start:Longint; lpBI:PBITMAPINFOHEADER):DWORD;

const
     NUMINFILE = 30;

var
  mainFrm: TmainFrm;
  DefaultTitle:String;
  //CallBack Define
  elapsed:Longint;
  numframe:Longint;
  bufform:Longint;
  blk:BLOCKINFO;

  //Audio part
  hAudio:HWND;
  elapsedtimes:Longint;
  hFile:HWND;
  dlhPen:HPEN;
  lastsize:Integer = 0;
  str:Array [0..99] of char;
  lastaudio:Array [0..1023] of BYTE;

  //----global variables for board--------
  hLoopThread:HWND;
  hBoard:HWND;
  bActive:Longint=0;
  total:Smallint=2;
  iCurrUsedNo:MLONG = -1;
  intrMISCCONTROL:Longint; //b0:1

  bMaskMode:Smallint = 0; // mask disable

  seqfilename:LPSTR = 'ok.seq';
  dwMaxMemSize:Longword = 30 * 1024 * 1024;
  dwBufSize:MWORD;

  lNumImage:Longint = NUMINFILE;


  lpbi:LPBITMAPINFOHEADER;
  lpdib:LPSTR;
  lpMemory:LPSTR;

  lpDibPlay:LPDIBINFO;
  bDispToScreen:Integer;

  hwndPlay:HWND; //for ReplayDlgEx

  //non-centerize
  lScrnOffset:Longint;
  sampwidth,sampheight:Smallint;
  waveheader:WAVEFILEHEADER;

  //----------------------- window parts----------

  dlhWnd:HWND;

  dlhPalette:HPALETTE;

  bMakeMirror:Smallint = 0;		//软件x,y方向镜象
  iClientWidth:Integer;                   //客户区宽度
  iClientHeight:Integer;                  //客户区高度

  iNum:Integer = 2;
  NoCapture:Integer = 2;
  lphBoard:Array [0..5] of HWND;

  num:Longint;
  ratio:Single = 25;
  times:Longint;

  flag:Integer = 0;
  hStream:HWND;

  starttime:DWORD;

  count:Longint;
  TotalLength:Longint;

  lpMask:Array of Longword;

implementation

{$R *.lfm}

function exAllocateDIBMemory(lExpectSize:Longint):Longint;
begin
     if (lExpectSize <> 0)  then //new size memory wanted
     begin
          if (lpbi <> nil) then
             GlobalFree(HGLOBAL(lpbi));
          dwMaxMemSize := lExpectSize;
          LPSTR(lpbi) := LPSTR(GlobalAlloc(GPTR, lExpectSize));
          //GlobalMemoryStatus(&Status);

          if (lpbi = nil) then //if not allocated
          begin
               dwMaxMemSize := 4*(1 shl 20); //4M
               LPSTR(lpbi) := LPSTR(GlobalAlloc(GPTR,dwMaxMemSize));
          end;
          lpdib := LPSTR(lpbi)+5120; //keep 5k for bi
          lpMemory := LPSTR(lpbi)+2048*1024; //keep 2M for dib
          if (dwMaxMemSize >2048*1024+5120) then
             dwMaxMemSize := dwMaxMemSize-2048*1024+5120;

          if (lpbi = nil) then //still zero
          begin
               ShowMessage('Allocate memory failed !');
               Result := 0;
               Exit;
          end;
     end;

     Result := dwMaxMemSize+2048*1024+5120;
end;

function exGetTargetSize(hBoard:HWND; tgt:TARGET; var width:Smallint; var height:Smallint):Longint;
var
   dlrect:TRect;
   form:Longint;
   lpblk:LPBLOCKINFO;
begin
    if((tgt=DLSCREEN)  or (tgt=DLBUFFER)) then
    begin
        dlrect.right := -1;
        okSetTargetRect(hBoard, tgt, dlrect); //get current rect
//     if (width <> 0) then
        width := dlrect.right - dlrect.left;
//     if(height <> 0) then
        height := dlrect.bottom - dlrect.top;

        if (tgt=DLSCREEN) then
        begin
          form:=okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1
          //limit to video rect
	  dlrect.right := -1; //max. captured rect
          okSetTargetRect(hBoard, DLVIDEO, dlrect); //get video rect
//          if (width <> 0) then
             width := min(width, dlrect.right-dlrect.left);
//          if (height <> 0) then
             height := min(height, dlrect.bottom-dlrect.top);
        end
        else if(tgt=DLBUFFER) then
          form := okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, GETCURRPARAM); //-1
    end
    else
    begin
        if(tgt>DLBUFFER) then //from blkinfo
        begin
          lpblk:=LPBLOCKINFO(tgt);

          width:=lpblk^.iWidth;
          height:=Abs(lpblk^.iHeight);
          form:=MAKELONG(lpblk^.iFormType,lpblk^.iBitCount);
        end;
    end;
    Result:=form;
end;

function exSetBitmapHeader(lpbi:PBITMAPINFOHEADER;width:Smallint;height:Smallint;bits:Smallint;form:Smallint):Longint;
var
   wbytes:Longint;
   i:Integer;
   lpRGB:PBITMAPINFO;
begin

     if (lpbi=nil) then
     begin
          Result:=0;
          Exit;
     end;

     if(form = FORM_RGB555) then
	bits := 16;
     wbytes := ((((width * bits) + 31) and not(31)) shr 3);//bmp need 4 byte align

     lpbi^.biWidth := width;
     lpbi^.biHeight := height;

     lpbi^.biSize := sizeof(TBITMAPINFOHEADER);
     lpbi^.biPlanes := 1;

     lpbi^.biBitCount := bits;
     lpbi^.biSizeImage := wbytes*lpbi^.biHeight;

     lpbi^.biClrUsed := 0;
     //special format for 555,565 & 32
     if((form=FORM_RGB555) or (form=FORM_RGB565) or (form=FORM_RGB8888) ) then
         lpbi^.biCompression:=BI_BITFIELDS
     else
     	lpbi^.biCompression:=0;
     if(lpbi^.biCompression=BI_BITFIELDS) then//
     begin
          LPSTR(lpmask):=LPSTR(Longword(lpbi)+lpbi^.biSize);

          if(form=FORM_RGB555) then
          begin
               lpmask[2]:=$001f; //blue
               lpmask[1]:=$03e0;
               lpmask[0]:=$7c00;
          end
          else
          if(form=FORM_RGB565) then
          begin
               lpmask[2]:=$001f; //blue
               lpmask[1]:=$07e0;
               lpmask[0]:=$f800;
          end
          else
          if(bits=32) then
          begin
               lpmask[2]:=$0000ff;
               lpmask[1]:=$00ff00;
               lpmask[0]:=$ff0000;
          end;
     end
     else
     begin
          if(bits<=14) then // 8,10,12
          begin
               LPSTR(lpRGB):=LPSTR(lpbi);

               lpbi^.biClrUsed := min(256, lpbi^.biClrUsed);
               for i:=0 to Smallint(lpbi^.biClrUsed)-1 do
               begin
                    lpRGB^.bmiColors[i].rgbBlue:=i;
                    lpRGB^.bmiColors[i].rgbGreen:=i;
                    lpRGB^.bmiColors[i].rgbRed:=i;
                    lpRGB^.bmiColors[i].rgbReserved:=0;
               end;
          end;
     end;
     lpbi^.biClrImportant := lpbi^.biClrUsed;

     Result := lpbi^.biClrUsed;
end;

function exConvertBitmap(lpbi:PBITMAPINFOHEADER;lpdib:LPSTR):Boolean;
var
    i,wbytes:Longint;
    lpbuf:LPSTR;
    lptop,lpbottom:LPSTR;
begin
    if(lpbi=nil) then
    begin
        Result:=FALSE;
        Exit;
    end;
    if(lpbi^.biHeight=0) then
    begin
        Result:=FALSE;
        Exit;
    end;

    //inverse dib (top to bottom)
    wbytes:=lpbi^.biSizeImage Div lpbi^.biHeight;
    lpbuf:=LPSTR(GlobalAlloc(GPTR,wbytes));

    lptop:=lpdib;
    lpbottom:=lpdib+(lpbi^.biHeight-1)*wbytes;
    for i:=0 to (lpbi^.biHeight Div 2) - 1 do
    begin
        CopyMemory(lpbuf,lptop,wbytes);
        CopyMemory(lptop,lpbottom,wbytes);
        CopyMemory(lpbottom,lpbuf,wbytes);
        lptop:= lptop+wbytes;
        lpbottom:=lpbottom-wbytes;
    end;
    GlobalFree(HGLOBAL(lpbuf));
    Result:=TRUE;
end;

procedure exDisplayDIBInfo();
begin
    mainFrm.Caption := DefaultTitle + '- '+IntToStr(lpbi^.biWidth)+ ' x '+ IntToStr(lpbi^.biHeight)+' x '+IntToStr(lpbi^.biBitCount);
end;

function exSetDataToDIB(src:TARGET; start:Smallint; lpbi:PBITMAPINFOHEADER; lpdib:LPBYTE):Longint;
var
   blk:BLOCKINFO;
begin
    if (lpbi <> nil) then
    begin
	      //get image to app buffer from tgt
        blk.lpBits:=Pointer(lpdib);
	blk.iWidth:=lpbi^.biWidth;
	blk.iHeight:=-lpbi^.biHeight; //to invert y
	blk.iBitCount:=lpbi^.biBitCount;
	if(lpbi^.biCompression=BI_BITFIELDS) then
        begin
	    LPSTR(lpMask):=LPSTR(lpbi)+ lpbi^.biSize;
	    if(lpMask[1]=$03e0) then //555
	          blk.iFormType:=FORM_RGB555;
	end;

	Result:=okConvertRect(hBoard,TARGET(@blk),0,src,start,1);
    end;
end;

//------------callback example runtines----------
//bDispToScreen=0: not back display
//				1, back display
//				2: back display, and take same bits as screen
//				3: pseudo back display

function exBeginCapture(hBoard:HWND):Boolean;stdcall;
var
   width:Smallint;
   height:Smallint;
   w:Smallint;
   h:Smallint;
   blkform:Longint;
   i:Integer;
   palPalEntry:Array [0..255] of PALETTEENTRY;
   temp:Smallint;
begin
     if (bDispToScreen > 0) then
     begin
          bufform := exGetTargetSize(hBoard, DLBUFFER, width, height);

	  blkform := okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1


	  //treat rotate

	  temp := okSetConvertParam(hBoard, CONVERT_UPRIGHT, -1); //un
	  if (temp>0) then
          begin
	      temp := width;
              width := height;
	      height := temp;
	  end;
          exSetBitmapHeader(lpbi, width, height, HIWORD(blkform), LOWORD(blkform) );

	  if (bDispToScreen > 1) then //take same bits as screen for callback SetToScreen
          begin
	  	if (bDispToScreen =3) then //make pseudo-display
                begin
			exSetBitmapHeader(lpbi, width, height, HIWORD(blkform), LOWORD(blkform) );

			//just exam to set palette to yellow
			for i:=0 to 255 do
                        begin
				palPalEntry[i].peRed := i;
				palPalEntry[i].peGreen := i;
				palPalEntry[i].peBlue := 0;
				palPalEntry[i].peFlags := 0;
			end;
			//if( LOWORD(blkform)!=FORM_GRAY8) ////set mapping palette
			okSetConvertParam(hBoard, CONVERT_PALETTE, Integer(@palPalEntry[0]));
                end;
          end;

     end;

     LPSTR(blk.lpBits) := lpdib;
     blk.iBitCount := lpbi^.biBitCount;
     //blk.iWidth:=Smallint(lpbi.biWidth);

     //if ((bMakeMirror And 1) =1) then //x mirror
     //	blk.iWidth := -Smallint(lpbi.biWidth)
     //else
	blk.iWidth := Smallint(lpbi^.biWidth);

     if( okSetCaptureParam(hBoard,CAPTURE_SAMPLEFIELD,-1)=0 ) then //sample in field by field
         if( LOWORD(okSetVideoParam(hBoard,VIDEO_SIGNALTYPE,-1))=1 ) then //interlace video
             lpbi^.biHeight:=lpbi^.biHeight*2; //double size for ht

     //if ((bMakeMirror And 2) = 2) then //y mirror
     //	blk.iHeight := Smallint(lpbi.biHeight) // y mirror
     //else
	blk.iHeight:=-Smallint(lpbi^.biHeight); //note: minus is for invert dib in y by ConvertRect

     elapsed:=GetTickCount();
     numframe:=0;
     exBeginCapture := TRUE;
end;

function exBackDisplay(hBoard:HWND;no:Longint):Boolean;stdcall;
var
   buffer:Array[0..1023] of Char;
   iscds:String;
begin

    numframe := numframe + 1;

//    StrPCopy(buffer, 'Ratio = ' + FloatToStr(Round(exCalcCaptureRatio() * 10) / 10) +'; Total frames = '+ IntToStr(numframe) + '; Current = ' + IntToStr(no));
    StrPCopy(buffer, 'Ratio = 25');
    SetWindowText(dlhwnd, buffer);


    if (bDispToScreen > 0) then
    begin
        if ((LOWORD(bufform)=FORM_GRAY10) or (LOWORD(bufform)=FORM_GRAY12) or (LOWORD(bufform)=FORM_GRAY16)) then //special
        begin
            //way 1
            okConvertRect(hBoard, TARGET(@blk), 0, DLBUFFER, Smallint(no), 1);
            //way 2
            //okReadRectEx(hBoard,DLBUFFER,Smallint(no),lpdib, MAKELONG(FORM_GRAY8,1));
        end
        else
        begin
            //Sleep(5);
            //way 1
            //okTransferRect(hBoard,TARGET(@blk),0,BUFFER,Smallint(no),1);
            okConvertRect(hBoard, TARGET(@blk), 0, DLBUFFER, Smallint(no), 1);
            //way 2
            //okReadRect(hBoard,DLBUFFER,Smallint(no),lpdib);
        end;
        InvalidateRect(dlhWnd, nil, FALSE);
    end;

    Result:=TRUE;
end;

function exSetToScreen(hBoard:HWND;no:Longint):Boolean;stdcall;
var
   buffer:Array[0..127] of Char;
begin
     numframe := numframe+1;
     StrPCopy(buffer, 'Ratio = ' + FloatToStr(Round(exCalcCaptureRatio() * 10) / 10) +'; Total frames = '+ IntToStr(numframe) + '; Current = ' + IntToStr(no));
     SetWindowText(dlhwnd, buffer);

     if ((LOWORD(bufform)=FORM_GRAY10) or (LOWORD(bufform)=FORM_GRAY12)  or (LOWORD(bufform)=FORM_GRAY16))  then //special
     begin
          //way 1
          okConvertRect(hBoard, TARGET(@blk), 0, DLBUFFER, Smallint(no), 1);

          //way 2
          //okReadRect(hBoard,DLBUFFER,Smallint(no),lpdib);
          //exConvertBitmap(lpbi,lpdib);
     end
     else
     begin
          //way 1
          okConvertRect(hBoard, TARGET(@blk), 0, DLBUFFER, Smallint(no), 1);
          //okTransferRect(hBoard, TARGET(@blk), 0, DLBUFFER, Smallint(no), 1);

          //way 2
          //okReadRect(hBoard,DLBUFFER,Smallint(no),lpdib);
          //exConvertBitmap(lpbi,lpdib);
     end;

     InvalidateRect(dlhWnd, nil, FALSE);
     UpDateWindow(dlhWnd);
     Result := TRUE;
end;

function exEndCapture(hBoard:HWND):Boolean;stdcall;
var
    buffer:Array[0..127] of Char;
begin
    elapsed:=GetTickCount()-elapsed;

    StrPCopy(buffer, 'Total frames = '+IntToStr(numframe)+';  elapsed time= '+IntToStr(elapsed)+' ms');
    SetWindowText(dlhwnd, buffer);

    //clear callback
    okSetSeqCallback(hBoard,nil,nil,nil);

    okStopCapture(hBoard);

    Result:=TRUE;
end;

function exCalcCaptureRatio:Single;
begin
     if (num >= 12) or (((okGetTickCount()-times)>2000) and (num>=2)) then
     begin
          times := GetTickCount() - times;
          ratio := num * 1000 / times;
          num := 0;
     end;

     if (num = 0) then
        times := GetTickCount();
     Inc(num);

     Result := ratio;
end;

function exCreateLoopCapture(hBoard:HWND; dlhWnd:HWND):HWND;
var
    hCapThread:HWND;
    dwCapThreadID:DWORD;

   //hDCBitmap:HWND;
   //hCapThread:HWND;
begin
    SetWindowLong(dlhWnd, GWL_USERDATA, Longint(hBoard));
    hCapThread := CreateThread (
        nil,
	0,
	@CaptureOneByOne,
	Pointer(dlhWnd),
	0,
	dwCapThreadID
	);

    Result := hCapThread;
end;

function CaptureOneByOne(dlhWnd:HWND):LRESULT;
var
	  count,  no, form:Longint;
	  width,height,bytes,lSize:Longint;
	  rcBuf, rcScr:TRect;
		hBoard:HWND;
	  tstr:String;
begin
	  count := 0;

	  hBoard := HWND(GetWindowLong(dlhWnd,GWL_USERDATA));

	  rcScr.right := -1;
	  okSetTargetRect(hBoard, DLSCREEN, rcScr);
	  form := okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,-1);

	  rcBuf.right := -1;
	  okSetTargetRect(hBoard, DLBUFFER, rcBuf);

	  width := rcBuf.right-rcBuf.left;
	  height := rcBuf.bottom-rcBuf.top;
	  bytes := HIWORD(form+7) div 8 * 8;
	  lSize := 2048+Longint(width)*bytes*height*2;
	  lpbi := PBITMAPINFOHEADER(GlobalAlloc(GPTR,lSize));
	  exSetBitmapHeader(lpbi, short(width), short(height), HIWORD(form), HIWORD(form));

	  //BlkInfo.iWidth=rcBuf.right-rcBuf.left;
	  //BlkInfo.iHeight=-(rcBuf.bottom-rcBuf.top);
	  //BlkInfo.iBitCount=HIWORD(form);//lpApi->byScrBits; //buf
	  //BlkInfo.iFormType=LOWORD(form);//lpApi->iScrForm;
	  //BlkInfo.lBlockStep=0;
	  //BlkInfo.lpBits=(LPBYTE)lpbi+2048;

	  while (True) do
	  begin
		    no := okGetSeqCapture(hBoard, 0, count); //start capture
                    Inc(count);

		    DrawToWndDC(dlhWnd, hBoard, no, lpbi);

                    //tstr := ' Ratio = %5.2f; Total frames =%6i; Current =%6i;  Paint times=%4i     ",exCalcCaptureRatio(),numframe, no,elapsed);
		    //SetWindowText(hwnd,string);

	  end;

	  Result := 1;
end;

function DrawToWndDC(dlhWnd:HWND; hBoard:HWND; start:Longint; lpBI:PBITMAPINFOHEADER):DWORD;
var
    hdc:HWND;
    dlrect, rcBuf:TRect;
    //LPBYTE		lpDIB;
    width,height,form:Integer;
    elapsed,elapsed1:Longint;
    BlkInfo:BLOCKINFO;
    dwPaintTime:DWORD;
    //LPDIRECTDRAWSURFACE     lpDDSPrimary=0;

    lret:Longint;
begin
	  dlrect.right := -1;
	  okSetTargetRect(hBoard, DLSCREEN, dlrect);
	  form := okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, -1);

	  width := dlrect.right - dlrect.left;
	  width := max(4,width);
	  height := dlrect.bottom - dlrect.top;
	  height := max(1,height);

	  rcBuf.right := -1;
	  okSetTargetRect(hBoard, DLBUFFER, rcBuf);
	  BlkInfo.iType := BMPHEADER;//		BLKHEADER;//
	  BlkInfo.iWidth := short(rcBuf.right-rcBuf.left);
	  BlkInfo.iHeight := -short(rcBuf.bottom-rcBuf.top);
	  BlkInfo.iBitCount := HIWORD(form);//lpApi->byScrBits; //buf
	  BlkInfo.iFormType := LOWORD(form);//lpApi->iScrForm;
	  BlkInfo.lBlockStep := 0;
	  LPSTR(BlkInfo.lpBits) := LPSTR(lpBI) + 2048;

	  okConvertRect(hBoard, TARGET(@BlkInfo), 0, DLBUFFER, start, 1); //


	  lpDIB := LPSTR(lpBI)+2048; //okGetBufferAddr(lpApi,0); //

    exit;
	//if(!(lpApi->lcvtFieldExtend&0x2000) )
	//sync
		//if(dwPaintTime<dwFieldPeriod) //paint faster than monitor fresh
//			okWaitVerticalSync(hBoard,0);
		//	okWaitVerticalSync(lpApi,1);

	  elapsed := okGetTickCount();
exit;
	  if (okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1) = 0) then //0: sync
    begin
		    lret := SendMessage(dlhWnd,WM_ASKWAITVERTICAL,0,0);
		    if (lret = 0) then //not support message mode
			      okWaitVerticalSync(hBoard, FALSE);
	  end;

	  elapsed1 := okGetTickCount()-elapsed;

    exit;
	  hDC := GetDC(dlhWnd);
	//lplpDD[0]->lpVtbl->GetGDISurface(lplpDD[0], &lpDDSPrimary);
	//lpDDSPrimary->lpVtbl->GetDC(lpDDSPrimary,&hDC);

	//SetScreenPalette(lpApi, hDC);
	//SetStretchBltMode(hDC,STRETCH_DELETESCANS);

	  MapWindowPoints(HWND_DESKTOP, dlhWnd, dlrect, 2);

		//sprintf(str,"left=%d,right=%d",rect.left,rect.right);
		//TextOut(hDC,0,0,str,strlen(str));
    {
  	SetDIBitsToDevice(hdc,
				dlrect.left,dlrect.top,
				width,height,
				0, lpBI.biHeight-height-0,
				0,lpBI.biHeight,
				lpDIB,
				(PBITMAPINFO(lpBI))^,
				DIB_RGB_COLORS
				);
     }

//			StretchDIBits(hDC,
//				rect.left,rect.top,
//				//lpBI->biWidth,lpBI->biHeight,
//				width,height,
//				//0,0,
//				LOWORD(lpApi->lcapScrOffsetVid), lpBI->biHeight-height-HIWORD(lpApi->lcapScrOffsetVid),
//				//lpBI->biWidth,lpBI->biHeight,
//				width,height,
//				lpDIB,(LPBITMAPINFO)lpBI,
//				DIB_RGB_COLORS,SRCCOPY);
//

	  dwPaintTime := WORD(okGetTickCount()-elapsed-elapsed1);



	//set bitmap header same as screen
	//SetBitmapData(lpApi, SCREEN, 0, lpApi->lpWndBuf, NULL);

	//ClientToScreen
	//----comp screen pos

	//lpDDSPrimary->lpVtbl->ReleaseDC(lpDDSPrimary,&hDC);

	  ReleaseDC(dlhWnd, hDC);



	  Result := dwPaintTime;
end;

function exFillOutLUT(hBoard:HWND; index:Smallint):Boolean;
var
    bLUT:Array[0..767,0..2] of BYTE;
    i,bits,start,num,gray:Smallint;
    iLUT:Array[0..255] of Smallint;
    wLUT:Array[0..4095,0..2] of WORD;
begin
    start:=0;
    num:=180;
    gray:=256;

    //check how much bits LUT suppored
    bits := Smallint(okFillOutLUT(hBoard, nil, 0, 0));

    if (bits <= 8) then
    begin
        case (index) of
        0:      //normal
            begin
                for i:=0 to gray-1 do
                begin
                        bLUT[i,0]:=BYTE(i);
                        bLUT[i,1]:=BYTE(i);
                        bLUT[i,2]:=BYTE(i);
                end;
            end;
        1:  //inverse
            begin
                for i:=0 to num-1 do
                begin
                        bLUT[i,0]:=BYTE(num-i);
                        bLUT[i,1]:=BYTE(num-i);
                        bLUT[i,2]:=BYTE(num-i);
                end;
                for i:=num to gray-1 do
                begin
                        bLUT[i,0]:=0;
                        bLUT[i,1]:=0;
                        bLUT[i,2]:=0;
                end;
            end;
        2:  //absolute for M60A
            begin
                for i:=0 to 127 do
                begin
                        bLUT[i,0]:=BYTE(i);
                        bLUT[i,1]:=BYTE(i);
                        bLUT[i,2]:=BYTE(i);
                end;
                for i:=128 to gray-1 do
                begin
                        bLUT[i,0]:=BYTE(256-i);
                        bLUT[i,1]:=BYTE(256-i);
                        bLUT[i,2]:=BYTE(256-i);
                end;
            end;
        3: //dsa absolute for M60A
            begin
	        //1. take true value with minus
		for i:=0 to 127 do //>0  0~127
                    iLUT[i] := i;
                for i:=128 to gray - 1 do //<0 -1~-128
                    iLUT[i] := i-256;
                //2. inverse at gray 165
                for i:=0 to 255 do //37~293
                    iLUT[i] := 165-iLUT[i];
                //3. stretch in several sects
                for i:=0 to 255 do //12~245
                begin
                    if  iLUT[i]<105 then //12~35
                        iLUT[i] := Round(0.334 * iLUT[i])
                    else
                        if  iLUT[i]<165 then //35~150
                            iLUT[i] := Round((1.916*iLUT[i]-166))
                        else
                            if iLUT[i]<205  then //150~245
                                iLUT[i] := Round((2.38*iLUT[i]-242))
					                  else  //245~255
						                    iLUT[i] := Round((0.113*iLUT[i]+222));
                end;
                //4. to lut in byts
                for i:=0 to 255 do
                begin
                        bLUT[i][0] := Byte(iLUT[i]);
                        bLUT[i][1] := Byte(iLUT[i]);
                        bLUT[i][2] := Byte(iLUT[i]);
                end;
            end;
            else
            begin
                Result:=FALSE;
                exit;
            end;

            okFillOutLUT(hBoard, @bLUT[0,0], start, gray);
            Result := TRUE;
        end;
    end
    else
    begin
        gray := 1 shl bits;
	num :=  gray-1;
	case (index) of
	0: //normal
	    for i:=0 to gray-1 do
            begin
		wLUT[i, 0] := i;
		wLUT[i, 1] := i;
		wLUT[i, 2] := i;
	    end;
	1: //inverse
	    for i:=0 to num do
            begin
	        wLUT[i, 0] := (num-i);
		wLUT[i, 1] := (num-i);
		wLUT[i, 2] := (num-i);
	    end;
	else
            begin
	        Result := False;
                exit;
            end;
	end;
	okFillOutLUT(hBoard, @wLUT[0,0], start, gray);
    end;

end;

//create wav file by way of callback function of capture audio function
procedure exCreateAudioFile2(hAudio:HWND; szFileName:LPSTR; lSampFrq:Longint; iSampBits:Smallint);
var
    dwCmd:DWORD;
begin
	//set parameters
	okSetAudioParam(hAudio,AUDIO_SAMPLEFRQ,lSampFrq);
	okSetAudioParam(hAudio,AUDIO_SAMPLEBITS,iSampBits);
	okSetAudioParam(hAudio,AUDIO_INVOLUME,250);

	//make header of wav file
	StrCopy(waveheader.RIFF,'RIFF');
	StrCopy(waveheader.WAVE,'WAVE');
	StrCopy(waveheader.fmt,'fmt ');
	waveheader.lHeadSize := $10;
	StrCopy(waveheader.data,'data');
	//waveheader.wFormatTag := WAVE_FORMAT_PCM;//0x10;
	waveheader.wFormatTag := $10;//0x10;
	waveheader.nChannels := 1;

	waveheader.nSamplesPerSec := lSampFrq;
	waveheader.nAvgBytesPerSec := lSampFrq * (iSampBits div 8);
	waveheader.nBlockAlign := 2;
	waveheader.wBitsPerSample := iSampBits;

	//create file
        hFile := CreateFile(szFileName, GENERIC_READ and GENERIC_WRITE, 0, nil, OPEN_ALWAYS, 0, 0);

	waveheader.lFileLength := sizeof(WAVEFILEHEADER);
        WriteFile(hFile,waveheader,sizeof(WAVEFILEHEADER),dwCmd,nil);
	waveheader.lDataLength := 0;

	//capture audio data
	okCaptureAudio(hAudio, DLBUFFER, @exWriteAudioData, 0);
end;

//write audio data to file by this callback function
function  exWriteAudioData(hAudio:HWND; var lpAudBuf:BYTE; length:Longint):Boolean;stdcall;
var
    dwCmd:DWORD;
begin
	if(length<>0) then //write audio data to file
        begin
                WriteFile(hFile,lpAudBuf,length,dwCmd,nil);
		waveheader.lDataLength := waveheader.lDataLength + length;

		//display audio data
		//exDrawAudio(hAudio, Pointer(lpAudBuf),length);
	end
	else  //capture ended, so close the file
        begin
		waveheader.lFileLength := waveheader.lFileLength + waveheader.lDataLength;
                SetFilePointer(hFile, 0, nil, FILE_BEGIN);
		WriteFile(hFile,waveheader,sizeof(WAVEFILEHEADER),dwCmd,nil);
		CloseHandle(hFile);
	end;

	Result := True;
end;

function exEndCaptureStream(hStream:HWND):Boolean;
begin
    if (hStream <> 0) then
    begin
		    //test pause
		    //okStopCaptureStream(hStream,1); //pause
		    //Sleep(5000);
		    //okStopCaptureStream(hStream,2); //re-encode
		    //Sleep(10000);


		    okStopCaptureStream(hStream, 0);

		    total := Smallint(okStopCaptureStream(hStream, 0));

//		    okCloseStream(hStream);
		    //hStream := 0;
		    //way1 and way2 end file

		    elapsedtimes := okGetTickCount() - elapsedtimes;
		    mainFrm.Caption := ' Stoped ! captured times = ' + IntToStr(elapsedtimes) + ' ms; Length=' + IntToStr(total);
    end;

    Result := True;
end;

//create wav file by way of using capture audio function directly
function exCreateStreamFile3(hStream:HWND; szFileName:LPSTR):Boolean;
begin
	//set stream parameters

	//okSetStreamParam(hAudio,AUDIO_CALLINTERVAL,20);

	elapsed := okGetTickCount();

	//make wav file by call this function
	Result := Boolean(okCaptureStream(hStream, TARGET(szFileName), @exMsgCallback, 0));

	//Result := True;
end;

function exMsgCallback(hStream:HWND; lpStreamBuf:LPBYTE; length:Longint):Boolean;stdcall;
var
    currtime:Longint;
begin
    if (length = 0) then //stoped
    begin
        Result := False;
	exit;
    end;

    currtime := okGetTickCount() - elapsed;

    TotalLength := TotalLength + length;
    if (currtime <> 0) then
    begin
        StrPCopy(str, ' MPEG2 Captured Times= ' + IntToStr((okGetTickCount()-starttime) Div 1000) + ' Seconds;  Section = ' + IntToStr(length) + ';  Rate = ' + IntToStr(TotalLength Div (okGetTickCount()-elapsed)) + ' (KB/S)     ');
        SetWindowText(dlhwnd, str);

	elapsed := okGetTickCount();
	TotalLength := 0;
    end;
    Inc(count);

    Result := True;
end;

function exFillInputLUT(hBoard:HWND;index:Smallint):Boolean;
var
    i,bits,start,num,gray:Smallint;
    bLUT:Array[0..255, 0..2] of BYTE;
    wLUT:Array[0..4095, 0..2] of WORD;
begin
    start := 0;

    //check how much bits LUT suppored
    bits := Smallint(okFillInputLUT(hBoard, nil, 0, 0));

    if (bits = -1) then
    begin
        Result := False;
	exit; //not support
    end;

    if bits<=8 then //for 8 bits lut
    begin
        num := 255;
        gray := 256;

	case (index) of
        0: //normal
	    for i:=0 to gray-1 do
            begin
	        bLUT[i, 0] := BYTE(i);
		bLUT[i, 1] := BYTE(i);
		bLUT[i, 2] := BYTE(i);
	    end;
	1: //inverse
            begin
	        for i:=0 to num-1 do
                begin
		    bLUT[i, 0] := BYTE(num-i);
		    bLUT[i, 1] := BYTE(num-i);
		    bLUT[i, 2] := BYTE(num-i);
                end;
		for i:=num to gray-1 do
                begin
		    bLUT[i, 0] := 0;
		    bLUT[i, 1] := 0;
		    bLUT[i, 2] := 0;
		end;
            end;
        else
            begin
                Result := False;
		exit;
            end
	end;
	okFillInputLUT(hBoard, @bLUT[0,0], start, gray);

    end
    else  //for great than 8 bits lut
    begin//max for 12 bits
        gray := 1 shl bits;

	case (index) of
	0: //normal
	    for i:=0 to gray-1 do
            begin
	        wLUT[i, 0] := i;
		wLUT[i, 0] := i;
		wLUT[i, 0] := i;
	    end;
	1: //inverse
	    for i:=0 to gray-1 do
            begin
		wLUT[i, 0] := (gray-i-1);
		wLUT[i, 0] := (gray-i-1);
		wLUT[i, 0] := (gray-i-1);
	    end;
	    else
            begin
                Result := False;
		exit;
            end;
	end;
	okFillInputLUT(hBoard, @wLUT[0,0], start, gray);
    end;

    Result := True;
end;

function exGetBitmapData(hBoard:HWND; src:TARGET; start:Integer; lpbi:PBITMAPINFOHEADER; var lpdib:LPSTR):Longint;
var
   width,height:Smallint;
   form:Longint;
   m:longint;
begin
     form := exGetTargetSize(hBoard, src, width, height);

     if(src<=DLBUFFER) then //not from blkinfo
         //take form as screen
         form:=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1

     exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form) );

     exSetDataToDIB(src, start, lpbi, LPBYTE(lpdib));

     Result:= LOWORD(form);
end;


{ TmainFrm }


procedure TmainFrm.FormCreate(Sender: TObject);
var
   i:Integer;
   str:Array [0..100] of char;
begin
    //创建窗体
    {Application.OnMinimize := AppOnMin;
    Application.OnRestore := AppOnRestore;}
    okGetProgramInfo(VERSION, str, 100);
    DefaultTitle := 'OK系列图象设备演示/测试程序 OkDemo ' + str;
    Caption := DefaultTitle;
    lNumImage := NUMINFILE;
    dlhWnd := mainFrm.WindowHandle;
    Freeze.Enabled := FALSE;

    CenterScreen.Checked := exGetInitSet();

    hBoard := exOpenCard(dlhWnd);

    //make mirror when convert
    okSetConvertParam(hBoard, CONVERT_MIRROR, bMakeMirror);

    for i := 0 to 4 do lphBoard[i] := 0;
    //make mirror when convert
    okSetConvertParam(hBoard, CONVERT_MIRROR, bMakeMirror);
end;

procedure TmainFrm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
    //退出程序
    exCloseThisBoard(hBoard);
    hBoard := 0;

    GlobalFree(HGLOBAL(lpbi));
    lpbi := nil;
    GlobalFree(HGLOBAL(lpdib));
    lpdib := nil;
    GlobalFree(HGLOBAL(lpMemory));
    lpMemory := nil;
    exSaveInitSet;
end;

procedure TmainFrm.CopyToClipbClick(Sender: TObject);
var
   hDIB:HWND;
   size:DWORD;
   lpbuf:LPBYTE;
begin
    if( OpenClipboard(dlhwnd) ) then
    begin
         if(lpbi^.biClrUsed = 256) then
             size:=1024
         else
             size:=0;
         if ((lpbi^.biBitCount = 16) or (lpbi^.biBitCount = 32)) then
             size := size + 3 * sizeof(DWORD);
         size:=size+lpbi^.biSize+lpbi^.biSizeImage;

         hDIB:=GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, size);
         lpbuf:=GlobalLock(hDIB);
         CopyMemory(lpbuf, lpbi, size-lpbi^.biSizeImage);
         CopyMemory(LPSTR(lpbuf)+size-lpbi^.biSizeImage, lpdib, lpbi^.biSizeImage);
         GlobalUnlock(hDIB);

         SetClipboardData(CF_DIB,hDIB);
         CloseClipboard();
    end;
end;

procedure TmainFrm.AboutMenuClick(Sender: TObject);
begin
    //系统信息
    if(bActive<>0) then
        okStopCapture(hBoard);
    MessageBeep(MB_ICONEXCLAMATION);
    AboutBox.ShowModal;
end;

procedure TmainFrm.AbsoluteDsaClick(Sender: TObject);
begin
    //绝对值DSA显示
    exFillOutLUT(hBoard, 3);
end;

procedure TmainFrm.AbsoluteLutClick(Sender: TObject);
begin
    //绝对值输出显示
    exFillOutLUT(hBoard, 2);
end;

procedure TmainFrm.AsyncMulCapClick(Sender: TObject);
var
   lIndex:MLONG;
   dwBufSize:MWORD;
   rect0,rect1:TRect;
   hei:Integer;
   lphBoard:Array[0..3] of HWND;
   dlmsg:MSG;
   pt:Pointer;
begin
    lIndex:=0;
    //open specified board
    lphBoard[0]:=okOpenBoard(lIndex);
    lIndex:=1;
    lphBoard[1]:=okOpenBoard(lIndex);

    if( lphBoard[0] <> 0) then //if success
    begin
        mainFrm.Caption :=' Any key to stop !';

        okGetAvailBuffer(pt, dwBufSize);
        okLockBuffer(lphBoard[0],dwBufSize Div 2,pt);
        okLockBuffer(lphBoard[1],dwBufSize Div 2,pt);

        rect0.right:=-1;
        okSetTargetRect(lphBoard[0],DLVIDEO, rect0);
        hei:=rect0.bottom-rect0.top;

        rect0:=GetClientRect();
        MapWindowPoints(mainFrm.Handle ,HWND_DESKTOP,rect0,2);
        if( CenterScreen.Checked or (hei<(rect0.bottom-rect0.top)) ) then
            rect0.top:=rect0.top+(rect0.bottom-rect0.top-hei) Div 2;

        rect1:=rect0;
        rect0.right:=(rect0.right+rect0.left) Div 2-1;
        okSetTargetRect(lphBoard[0], DLSCREEN, rect0);

        rect1.left:=(rect1.right+rect1.left) Div 2+1;
        //rect1.left=(rect1.right+rect1.left)/2;
        okSetTargetRect(lphBoard[1], DLSCREEN, rect1);
        //okSetTargetRect(lphBoard[1], SCREEN, &rect);

        okMulCaptureByBuffer(lphBoard[0],DLSCREEN,0,0);

        while( True ) do
        begin
             //PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
    	 GetMessage(dlmsg, mainFrm.Handle, 0, 0);
             if( (dlmsg.message=WM_KEYDOWN) or
                 (dlmsg.message=WM_LBUTTONDOWN) or
                 (dlmsg.message=WM_NCLBUTTONDOWN) ) then
                 break;
        end;
        okStopCapture(lphBoard[0]);
        okStopCapture(lphBoard[1]);

        //close specified board
        okCloseBoard(lphBoard[0]);
        okCloseBoard(lphBoard[1]);

        okUnlockAllBuffer();

        mainFrm.Caption :=' Stoped !';
    end;
end;

procedure TmainFrm.BackToScreenClick(Sender: TObject);
begin
    //使回送屏幕
    BackToScreen.Checked := Not(BackToScreen.Checked);
end;

procedure TmainFrm.Buffer0ToBuffer1Click(Sender: TObject);
begin
    //缓存的第0幅传送到第1幅
    okTransferRect(hBoard,DLBUFFER,1,DLBUFFER,0,1);
end;

procedure TmainFrm.Buffer1ToBuffer0Click(Sender: TObject);
begin
    //缓存的第1幅传送到第0幅
    okTransferRect(hBoard,DLBUFFER,0,DLBUFFER,1,1);
end;

procedure TmainFrm.BufferToFrameClick(Sender: TObject);
begin
    //缓存的第0幅传到帧存
    Freeze.Enabled:=TRUE;
    okTransferRect(hBoard,DLFRAME,0,DLBUFFER,0,1);
end;

procedure TmainFrm.BufferToScreenClick(Sender: TObject);
begin
    //缓存0传送到屏幕
    exSetDataToDIB(DLBUFFER, 0, lpbi, LPBYTE(lpdib));
    InvalidateRect(DLhWnd,nil,FALSE);
end;

procedure TmainFrm.CapSequenceClick(Sender: TObject);
begin
    //序列采集
    if okOpenSeqCaptureDlg(hBoard, mainFrm.WindowHandle ) then
       total:=1
    else
       total:=0;
    //dest(buffer) rect may be changed
    exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
    //get current size
    sampwidth:=lpbi^.biWidth;
    sampheight:=lpbi^.biHeight;
    lScrnOffset := exSetToWndRectEx(hBoard, mainFrm.WindowHandle, CenterScreen.Checked);
end;

procedure TmainFrm.CapToBufferClick(Sender: TObject);
var
   dwTemp:MWORD;
   num:Longint;
begin
    //序列采到缓存
    if (BackToScreen.Checked) then
            bDispToScreen := 1
    else
    	bDispToScreen := 0;

    Freeze.Enabled:=TRUE;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    num:=okGetBufferSize(hBoard,nil,dwTemp);//
    okCaptureTo(hBoard,DLBUFFER,0,num);//
end;

procedure TmainFrm.CapToDirectClick(Sender: TObject);
var
   dlMsg: Msg;
begin
    //(待停)实时采
    okStopCapture(hBoard);

    //must not to upright
    UptoRight.Checked := FALSE;
    UptoLeft.Checked := FALSE;
    okSetConvertParam(hBoard,CONVERT_UPRIGHT,0); //un to upright

    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    if( okCaptureToScreen(hBoard)<>MLONG(True) ) then
        ShowMessage('Please try 256 color mode for B/W grabber, and 24 bits mode for color grabber.')
    else
    begin
         LazActive.Enabled :=False;
         Freeze.Enabled :=True;
         bActive:=1;
         SetCapture(dlhWnd);
         //PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
         while(True) do
         begin
    	//PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
    	GetMessage(dlMsg, dlhWnd, 0, 0);
    	if( (dlmsg.message=WM_KEYDOWN) or
    		(dlmsg.message=WM_LBUTTONDOWN) or
    		(dlmsg.message=WM_NCLBUTTONDOWN) ) then
    			break;
         end;
         ReleaseCapture();
         //UnlockCapScreen(hBoard);
         FreezeClick(nil);
         InvalidateRect(dlhWnd,nil,TRUE);
         //UpdateWindow(NULL);
    end;
end;

procedure TmainFrm.CapToForeverClick(Sender: TObject);
begin
    //(恒久)实时显示
    //must to not match
    MatchClient.Checked := False;

    //must not to upright
    UptoRight.Checked := FALSE;
    UptoLeft.Checked := FALSE;
    okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright

    exGetBitmapHeader(hBoard, DLSCREEN, lpbi);
    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    //UpdateWindow(hWnd);
    okStopCapture(hBoard); //confirm
    //specail capture to frame
    if( okGetTypeCode(hBoard,nil)=OK_C70 ) then
    begin
         okCaptureTo(hBoard,DLFRAME,0,0);
         LazActive.Enabled := False;
         Freeze.Enabled := True;
    end //normal to screen
    else if( okCaptureToScreen(hBoard) <> MLONG(TRUE) ) then
        ShowMessage('Please try 256 color mode for B/W grabber, and 24 bits mode for color grabber.')
    else
    begin
         LazActive.Enabled:=FALSE;
         Freeze.Enabled:=TRUE;
         bActive:=2;
    end;
end;

procedure TmainFrm.CapToFrameClick(Sender: TObject);
begin
    //实时采到帧存
    Freeze.Enabled:=TRUE;
    okCaptureTo(hBoard,DLFRAME,0,0); //cont.
end;

procedure TmainFrm.CapToInDirectClick(Sender: TObject);
var
    lret:Longint;
begin
    //（经缓存）实时显
    Freeze.Enabled := TRUE;
    okSetConvertParam(hBoard, CONVERT_PALETTE, 0);

    lret := okSetCaptureParam(hBoard, CAPTURE_MISCCONTROL, -1) and (not $3);
    okSetCaptureParam(hBoard, CAPTURE_MISCCONTROL, lret); //normal

    bDispToScreen := 2;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    //just capture to buffer
    okCaptureByBuffer(hBoard, DLBUFFER, 0, 0);//0: cont.
end;

procedure TmainFrm.CapToMemoryClick(Sender: TObject);
var
    num:Integer;
    blk:BLOCKINFO;
begin
    //序列采到内存
    if (BackToScreen.Checked) then
            bDispToScreen := 1
    else
    	bDispToScreen := 0;

    Freeze.Enabled :=TRUE;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    if (lpbi<>nil) then
    begin
         blk.iType:=BLKHEADER;
         LPSTR(blk.lpBits):=lpMemory;
         num := dwMaxMemSize Div exGetFrameSize(hBoard);
         lpMemory^ := Char(0);
         okCaptureByBuffer(hBoard,TARGET(lpMemory),0,num);
    end;
end;

procedure TmainFrm.CapToMonitorClick(Sender: TObject);
begin
    //显示视频输入
    Freeze.Enabled:=TRUE;
    okCaptureTo(hBoard,DLMONITOR,0,0);//0: cont.
end;

procedure TmainFrm.CapToPseudoClick(Sender: TObject);
begin
    //经缓存伪彩色显示
    Freeze.Enabled := TRUE;
    bDispToScreen := 3;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    //just capture to buffer
    okCaptureByBuffer(hBoard, DLBUFFER, 0, 0);//0: cont.
end;

procedure TmainFrm.CapToSeqfileClick(Sender: TObject);
var
    filename:AnsiString;
begin
    //序列采到文件(ok.seq)
    if (BackToScreen.Checked) then
        bDispToScreen := 1
    else
    	bDispToScreen := 0;

    Freeze.Enabled :=TRUE;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);

    if (Not SaveDlg.Execute) then Exit;
    filename := ConvertEncoding(SaveDlg.FileName, 'utf8', 'ansi');
    if( Pos('.',FileName )=0 ) then Exit;
    SetSeqNum.ShowModal;

    //first delete ok.seq
    DeleteFile(FileName);

    case (SaveDlg.FilterIndex) of
    4:
        FileName := FileName + ',jpg,50';
    6:
        FileName := FileName + ',mjpg,60';
    7:
        FileName := FileName + ',mpg4';
    end;


    okCaptureByBuffer(hBoard, TARGET(FileName), 0, lNumImage);
end;

procedure TmainFrm.CaptureAudioClick(Sender: TObject);
var
   szFileName:Array [0..20] of char;
   lSampFrq:Longint;
   iSampBits:Smallint;
begin
    StrCopy(szFileName,'test.wav');
    lSampFrq:=8000;
    iSampBits:=8;

    hAudio:=okOpenAudio(hBoard, 0);
    if(hAudio <> 0) then
    begin
         elapsedtimes:=GetTickCount();

         dlhPen := CreatePen(PS_SOLID,1,RGB(0,255,0));

         //capture audio and create file
         exCreateAudioFile2(hAudio, szFileName, lSampFrq, iSampBits);

         Freeze.Enabled := True;
    end;
end;

procedure TmainFrm.CaptureMpeg2Click(Sender: TObject);
begin
    if (flag = 0) then
    begin
         CaptureMpeg2.Caption := '&G 停止采集 MPEG2';
         flag := 1;
         if (Not exCaptureStreamFile(hBoard, dlhWnd)) then
            flag := 0;
    end
    else
    begin
         exEndCaptureStream(hStream);
         CaptureMpeg2.Caption :=  '&G 采集 MPEG2';
         flag := 0;
    end;
end;

procedure TmainFrm.CenterScreenClick(Sender: TObject);
begin
    CenterScreen.Checked := Not CenterScreen.Checked;

    if (CenterScreen.Checked) then
        MatchClient.Checked := FALSE;

    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    mainFrm.Refresh;
end;

procedure TmainFrm.ContToBuffer0Click(Sender: TObject);
begin
    //实时采到缓存第0幅
    FREEZE.Enabled := TRUE;
    okCaptureTo(hBoard,DLBUFFER,0,0);
end;

procedure TmainFrm.ContToBuffer1Click(Sender: TObject);
begin
    //实时采到缓存第1幅
    FREEZE.Enabled := TRUE;
    okCaptureTo(hBoard,DLBUFFER,1,0);
end;

procedure TmainFrm.DisableActiveClick(Sender: TObject);
var
    lset:Longint;
begin
    lset := okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1);
    //if(MF_CHECKED==LOWORD(GetMenuState(hMenu,IDM_DISABLEACTIVE,MF_BYCOMMAND)))

    if ((lset and $800000) = 0) then //allow to be change
    begin
    	lset := lset or $800000;  // set special flag
    	if ((lset and $80) <> 0) then //disabled
    	begin
    		lset := lset and not($81);  // enable
    		okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,lset);
    		DisableActive.Checked := FALSE;
    	end
    	else
        begin
    		lset := lset or $81; //disable and change to control by interrupt
    		okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,lset);
    		DisableActive.Checked := TRUE;
    	end;
    	intrMISCCONTROL := okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1) and $3;
    end;
end;

procedure TmainFrm.DisableSyncVertClick(Sender: TObject);
var
    lset:Longint;
begin
    lset := okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1); //0: sync
    if (lset <> 0) then //disabled
    begin
    	okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,0); //un-disable
    	DisableSyncVert.Checked := FALSE;
    end
    else
    begin
    	okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,1);//disable
    	DisableSyncVert.Checked := TRUE;
    end;
end;

procedure TmainFrm.DispFromBufferClick(Sender: TObject);
var
   dwTemp:MWORD;
begin
    //序列回显缓存
    if (BackToScreen.Checked) then
        bDispToScreen := 1
    else
	      bDispToScreen := 0;
    FreezeClick(Sender);
    Freeze.Enabled := TRUE;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    num := okGetBufferSize(hBoard, nil, dwTemp);//
    okPlaybackFrom(hBoard, DLBUFFER, 0, num);//
end;

procedure TmainFrm.DispFromFileClick(Sender: TObject);
var
    filename:String;
begin
    //（循环）序列回显文件
    Freeze.Enabled := TRUE;
    if (BackToScreen.Checked) then
            bDispToScreen := 1
    else
    	bDispToScreen := 0;
    OpenDlg.Filter := 'Sequence *.seq|*.seq';
    OpenDlg.Title := '选择一序列文件';
    if (Not OpenDlg.Execute) then Exit;

    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);

    filename := ConvertEncoding(OpenDlg.FileName, 'utf8', 'ansi');
    //just get num
    if( Pos('.seq',FileName) <>0 ) then
        //just get num
        num:=okLoadImageFile(hBoard, LPSTR(FileName), 0, DLSCREEN, 0, 0)
    else
    begin
        SetSeqNum.ShowModal;
        num:=lNumImage;
    end;
    okPlaybackByBuffer(hBoard,TARGET(FileName),0,-num);
end;

procedure TmainFrm.DispFromFrameClick(Sender: TObject);
begin
    //连续回显帧存
    Freeze.Enabled :=TRUE;
    okPlaybackFrom(hBoard,DLFRAME,0,0); //cont.
end;

procedure TmainFrm.DispFromMemoryClick(Sender: TObject);
begin
    //（循环）序列回显内存
    Freeze.Enabled := TRUE;
    if (BackToScreen.Checked) then
            bDispToScreen := 1
    else
    	bDispToScreen := 0;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    if (lpbi<>nil) then
    begin
         num := dwMaxMemSize Div exGetFrameSize(hBoard);
         okPlaybackByBuffer(hBoard, TARGET(lpMemory), 0, -num);
    end;
end;

procedure TmainFrm.EnableMaskClick(Sender: TObject);
begin
    //允许位屏蔽
    if enablemask.Checked then
    begin
         enablemask.Checked :=False;
         bMaskMode := 0; //disable mask
    end
    else
    begin
         enablemask.Checked :=True;
         bMaskMode := 1; //positive mask
    end;
    okEnableMask(hBoard, bMaskMode); //set mask
end;

procedure TmainFrm.ExtTriggerClick(Sender: TObject);
var
   trigger:Integer;
begin
    //测试外触发
    okCaptureToScreen(hBoard);
    mainFrm.Caption := ' Waiting extern trigger...';
    trigger := okWaitSignalEvent(hBoard, EVENT_EXTTRIGGER, 10000);//max 10 seconds
    okStopCapture(hBoard);
    if (trigger = 1) then
        mainFrm.Caption := ' Extern trigger came.'
    else if (trigger = -1) then
        mainFrm.Caption := ' Not support trigger'
    else
        mainFrm.Caption := ' Waiting time out';
end;

procedure TmainFrm.FillInGLutClick(Sender: TObject);
begin
    okOpenSetLUTDlg(hBoard, dlhWnd, Nil);
end;

procedure TmainFrm.FormDestroy(Sender: TObject);
begin
    PostQuitMessage(0);
end;

procedure TmainFrm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  rcRect:TRECT;
  pt:TPoint;
  xx, yy:Integer;

  form, bufform:Longint;
  byBits:BYTE;
  lpPixel:LPBYTE;
  sTemp:Smallint;
  stride:MLONG;
  szSource:String;
  gray:WORD;
  szString:String;
  r, g, b:WORD;

  wPixel:WORD;
  dwPixel:DWORD;
  lForm:WORD;
  buffer:Array[0..512] of Char;
begin
    //2046 lpPixel err capture file
    exit;
     if (bActive <> 0) then exit;

     rcRect.left := LOWORD(lScrnOffset);
     rcRect.top := HIWORD(lScrnOffset);
     rcRect.right := rcRect.left + lpbi^.biWidth;
     rcRect.bottom := rcRect.top + lpbi^.biHeight;
     MapWindowPoints(dlhWnd, HWND_DESKTOP, rcRect, 2);

     pt.x := X;
     pt.y := Y;
     MapWindowPoints(dlhWnd, HWND_DESKTOP, pt, 1);

     xx := pt.x - rcRect.left;
     yy := pt.y - rcRect.top;

     if ((xx>=0) and (xx<lpbi^.biWidth) and (yy>=0) and (y<lpbi^.biHeight)) then
     begin
          //1. screen
          form := okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1
          byBits := BYTE(HIWORD(form));

          if (okGetCaptureStatus(hBoard, Boolean(2)) <> 0) then //capturing
          begin
 	     lpPixel :=LPBYTE(okGetTargetInfo(hBoard, DLSCREEN, 0, sTemp, sTemp, stride));
 	     LPSTR(lpPixel) := LPSTR(lpPixel) + pt.x*byBits Div 8 + pt.y*stride;
 	     szSource := 'SCREEN';
          end
          else  //forzen
          begin
 	     //wbytes=((((lpbi->biWidth*bits)+31)&~31)>>3);//bmp need 4 byte align
 	     byBits := BYTE(lpbi^.biBitCount);
 	     stride := (lpbi^.biWidth*byBits Div 8+3) Div 4*4; //dword align
 	     LPSTR(lpPixel) := LPSTR(lpdib)+x*byBits Div 8+(lpbi^.biHeight-y-1)*stride;
 	     szSource := ' DIB';
          end;

          if (byBits <=8 ) then //8 bits
          begin
               gray := lpPixel^;
 	      //gray=(BYTE)okReadPixel(hBoard,SCREEN,0,x,y-10);
 	      //okWritePixel(hBoard,SCREEN,0,x,y-10,0x00ffff);

               szString := '(' + IntToStr(pt.x-rcRect.left) + ',' + IntToStr(pt.y-rcRect.top) + ')' + szSource + '(' + IntToStr(gray) + ')';
          end
          else
          begin
               if (LOWORD(form) = FORM_RGB555) then
               begin
                    wPixel := (LPWORD(lpPixel))^;
                    b := (wPixel and $1f) shl 3;
 		   g := ((wPixel shr 5) and $1f) shl 3;
                    r := ((wPixel shr 10) and $1f) shl 3;
               end
               else
               if (byBits = 16) then
               begin
                    wPixel :=(LPWORD(lpPixel))^;
                    b := (wPixel and $1f) shl 3;
                    g := ((wPixel shr 5) and $3f) shl 2;
                    r := ((wPixel shr 11) and $1f) shl 3;
               end
 	      else
               if (byBits >= 24) then
               begin
                    dwPixel := (LPDWORD(lpPixel))^;
                    //ShowCursor(0); //
                    //dwPixel=okReadPixel(hBoard,SCREEN,0,x,y); //$
                    //okWritePixel(hBoard,SCREEN,0,x,y,0x00ffff);//$
                    //ShowCursor(1);

                    b := dwPixel and $ff;
                    g := (dwPixel shr 8) and $ff;
                    r := (dwPixel shr 16) and $ff;
               end;
               szString := '(' + IntToStr(pt.x-rcRect.left) + ',' + IntToStr(pt.y-rcRect.top) + ')' + szSource + '(' + IntToStr(r) + ',' + IntToStr(g) + ',' + IntToStr(b) + ')';
         end;

          //2. buffer
 	 bufform := okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, GETCURRPARAM); //-1

          if (LOWORD(bufform) <> LOWORD(form)) then
          begin
               dwPixel := okReadPixel(hBoard, DLBUFFER, -1, xx, yy); // read current frame
               lForm := LOWORD(bufform);
               if ((lForm = FORM_GRAY8) or (lForm = FORM_GRAY888) or (lForm = FORM_GRAY8888) or (lForm = FORM_GRAY10) or (lForm = FORM_GRAY12) or (lForm = FORM_GRAY16)) then
               begin
                    szString := szString +' BUFFER (' + IntToStr(dwPixel) + ')';
               end
               else if (lForm = FORM_RGB555) then
               begin
                    b := (dwPixel and $1f) shl 3;
                    g := ((dwPixel shr 5) and $1f) shl 3;
                    r := ((dwPixel shr 10) and $1f) shl 3;
                    szString := szString + ' BUFFER (' + IntToStr(r) + ',' + IntToStr(g) + ',' + IntToStr(b) +')';
               end
               else if ((lForm = FORM_RGB888) or (lForm = FORM_RGB8888) or (lForm = FORM_RGB8886)) then
               begin
                    b := dwPixel and $ff;
                    g := (dwPixel shr 8) and $ff;
                    r := (dwPixel shr 16) and $ff;
                    if (LOWORD(bufform) = FORM_RGB8886) then
                    begin
                         b := (b shl 2) or ((dwPixel shr 24) and $3);
                         g := (g shl 2) or ((dwPixel shr 26) and $3);
                         r := (r shl 2) or ((dwPixel shr 28) and $3);
                    end;
                    szString := szString + ' BUFFER (' + IntToStr(r) + ',' + IntToStr(g) + ',' + IntToStr(b) + ')';
               end
               else
               begin
                    //if(LOWORD(bufform)==FORM_RGB565) {
 		   b := (dwPixel and $1f) shl 3;
                    g := ((dwPixel shr 5) and $3f) shl 2;
                    r := ((dwPixel shr 11) and $1f) shl 3;
                    szString := szString + ' BUFFER (' + IntToStr(r) + ',' + IntToStr(g) + ',' + IntToStr(b) + ')';
               end;
          end;
     end;

     StrPCopy(buffer, mainFrm.Caption);
     buffer[75] := Char(0);            //because lazarus use utf-8
     mainFrm.Caption := buffer + '  ' + szString;
end;

procedure TmainFrm.FormPaint(Sender: TObject);
var
   dlrect:TRect;
   pt:TPoint;
   starty:Integer;
   scrbits:Smallint;

   size:Longint;
   sz:String;
   i:integer;
begin
    //1. way to treat replay dlg
    if((lpDibPlay<>nil) and (lpDibPlay^.hwndPlayBox<>0)) then
    begin
        size:=lpDibPlay^.lpbi^.biSize;
        if(lpDibPlay^.lpbi^.biCompression<>0) then
           size:=size+sizeof(DWORD)*3
        else
            size:=size+lpDibPlay^.lpbi^.biClrUsed*sizeof(RGBQUAD);
        CopyMemory(lpbi,lpDibPlay^.lpbi,size);
        CopyMemory(lpdib,lpDibPlay^.lpdib,lpDibPlay^.lpbi^.biSizeImage);
    end;

    if(lpbi<>nil) then
    begin
        scrbits:=HIWORD(okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM));
        dlrect:=GetClientRect();
        if(lpbi^.biHeight>dlrect.bottom) then
            dlrect.top:=lpbi^.biHeight-dlrect.bottom
        else
            dlrect.top:=0;

        pt.x:=LOWORD(lScrnOffset);
        pt.y:=HIWORD(lScrnOffset);
        ClientToScreen(pt);
        //adjust x abs. offset to 4 align
        if ((pt.x Div 4) = 0) then
            pt.x := pt.x+4 - pt.x Div 4
        Else
            pt.x :=  pt.x;
        ScreenToClient(pt);

        exSetPaletteToWnd(mainFrm.Canvas.Handle);

	if (okSetConvertParam(hBoard, CONVERT_NOSYNCSCREEN, -1) = 0) then //0: sync
		    okWaitVerticalSync(hBoard, FALSE);

        if not MatchClient.Checked then
            SetDIBitsToDevice(mainFrm.canvas.handle,pt.x,pt.y,
              lpbi^.biWidth,lpbi^.biHeight,
              0,0,
              0,lpbi^.biHeight,
              lpdib,
              (PBITMAPINFO(lpbi))^,DIB_RGB_COLORS)
        else
        begin
            dlrect.left:=pt.x;
            dlrect.top:=pt.y;
            if( (iClientWidth>0) and (iClientHeight>0) ) then
            begin
                dlrect.right:=iClientWidth+dlrect.left;
                dlrect.bottom:=iClientHeight+dlrect.top;
            end;
//         i:=SetStretchBltMode(mainFrm.canvas.handle,STRETCH_DELETESCANS);
            SetStretchBltMode(mainFrm.Canvas.Handle , STRETCH_DELETESCANS);
            StretchDIBits(mainFrm.canvas.handle,dlrect.left,dlrect.top,
              dlrect.right,dlrect.bottom,
              0, 0,
              lpBI^.biWidth,lpBI^.biHeight,
              lpDIB,(PBITMAPINFO(lpbi))^,
              DIB_RGB_COLORS,SRCCOPY);
        end;
    end;
end;

procedure TmainFrm.FormResize(Sender: TObject);
var
   hTemp:HWND;
begin
    //改变窗口大小
    hTemp:=0;
    okStopCapture(hBoard);
    InvalidateRect(hTemp,nil,FALSE);
    okSetToWndRect(hBoard,dlhWnd);
    if(bActive<>0) then
        okCaptureToScreen(hBoard);
end;

procedure TmainFrm.FrameToBufferClick(Sender: TObject);
begin
    //帧存传到缓存的第0幅
    okConvertRect(hBoard,DLBUFFER,0,DLFRAME,0,1);
end;

procedure TmainFrm.FrameToScreenClick(Sender: TObject);
begin
    //帧存传到屏幕
    if(okConvertRect(hBoard,DLSCREEN,0,DLFRAME,0,1)>0) then
        exGetBitmapData(hBoard, DLSCREEN, 0, lpbi, lpdib);
end;

procedure TmainFrm.FreezeClick(Sender: TObject);
begin
    //停止
    {
		if (hAudio <> 0)  //audio capturing
				exEndCaptureAudio(hAudio);
        }

    if (hLoopThread <> 0) then
    begin
	TerminateThread(hLoopThread,0);
	hLoopThread := 0;
    end;
    exStopMulCapture(); //to stop in case mul-capturing

    okStopCapture(hBoard);
    //mainFrm.Refresh;
    if(bActive<>0) then
    begin
        //take buffer size
        exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
        exSetDataToDIB(DLSCREEN, 0, lpbi, LPBYTE(lpdib));
        exDisplayDIBInfo();
    end;
    bActive:=0;
    Freeze.Enabled:=FALSE;
    LazActive.Enabled:=TRUE;
    //InvalidateRect(hWnd,NULL,FALSE);

    okSetSeqCallback(hBoard, nil, nil, nil); //confirm to null

    //okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,intrMISCCONTROL|
    //			(okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&~0x3));
end;

procedure TmainFrm.InterFromBufferClick(Sender: TObject);
begin
    //(循环)中断控制回显缓存
    if (BackToScreen.Checked) then
        bDispToScreen := 1
    else
        bDispToScreen := 0;
    FreezeClick(Sender);
    Freeze.Enabled := TRUE;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    okPlaybackSequence(hBoard, 0, -1);//
end;

procedure TmainFrm.InterToIndirectClick(Sender: TObject);
var
    lret:Longint;
begin
    //（中断经缓存）实时显
    Freeze.Enabled := TRUE;
    okSetConvertParam(hBoard, CONVERT_PALETTE, 0);

    lret := okSetCaptureParam(hBoard, CAPTURE_MISCCONTROL, -1) and (not $3);
    okSetCaptureParam(hBoard, CAPTURE_MISCCONTROL, lret or 1); //normal

    bDispToScreen := 2;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    //just capture to buffer
    okCaptureByBuffer(hBoard, DLBUFFER, 0, 0);//0: cont.
end;

procedure TmainFrm.InverseInLutClick(Sender: TObject);
begin
    //反向输入查找表
    exFillInputLUT(hBoard, 1);
end;

procedure TmainFrm.InverseLutClick(Sender: TObject);
begin
    //反向输出显示
    exFillOutLUT(hBoard, 1);
end;

procedure TmainFrm.LazActiveClick(Sender: TObject);
var
    errcode:Longint;
    str:Array [0..119] of char;
    str1:Array [0..119] of char;
    bits:Longint;
begin
    //实时采
    //must to not match
    MatchClient.Checked := False;

    //must not to upright
    UptoRight.Checked := FALSE;
    UptoLeft.Checked := FALSE;
    okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright
    exGetBitmapHeader(hBoard, DLSCREEN, lpbi);
    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    //UpdateWindow(hWnd);
    okStopCapture(hBoard); //confirm
    //specail capture to frame
    if (okGetTypeCode(hBoard,nil) = OK_C70) then
    begin
         okCaptureTo(hBoard, DLFRAME, 0, 0);
         LazActive.Enabled := False;
         Freeze.Enabled := True;
    end //normal to screen
    else
        if (Longint(okCaptureToScreen(hBoard)) <= 0) then
        begin
    	    errcode := okGetLastError();

    	    if (errcode = ERR_FORMNOTSUPPORT) then
            begin
    	        bits := okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,-1);
    		okGetTypeCode(hBoard, str1);
                StrPCopy(str, str1 + ' does not support current ' + IntToStr(HIWORD(bits)) + ' bits mode !' + #13 + #13 + 'Please try other display mode.');
    		ShowMessage(str);

    		//MessageBox(hwnd,""
    		//	"\tLook up which format this card support ? \n\t\t Try 256 color or 24 bits color mode.",
    		//	"This card does not support current display mode !",MB_OK);
            end
    	    else //
            begin
                  StrPCopy(str, 'Some thing wrong ! Error Code = ' + IntToStr(errcode));
    		  ShowMessage(str);
            end
        end
        else
        begin
             LazActive.Enabled := FALSE;
             Freeze.Enabled := TRUE;
             bActive := 1;
        end;
end;

procedure TmainFrm.LoadConfigFileClick(Sender: TObject);
var
    filename:String;
begin
    ODlg.Filter := 'Config file for Ok Card  (*.OKF)|*.OKF|Config file just for sample (*.OKS)|*.OKS|Config file just for output (*.OKO)|*.OKO';

    if  (Not ODlg.Execute()) then Exit;
    filename := ConvertEncoding(ODlg.FileName, 'utf8', 'ansi');
    if (Pos('.', FileName )=0) then Exit;
  	okLoadConfigFile(hBoard, LPSTR(FileName));

    InitSetMenu(hBoard);
    exGetBitmapHeader(hBoard, DLBUFFER, lpbi); //set-lpbi
    //get current size
    sampwidth := short(lpbi^.biWidth);
    sampheight := short(lpbi^.biHeight);
    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    InvalidateRect(dlhWnd, nil, TRUE);
end;

procedure TmainFrm.LoadFileClick(Sender: TObject);
begin
    //装入图像文件
    exLoadImageFile(hBoard,dlhWnd);
    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    mainFrm.Refresh;
    exDisplayDIBInfo();
end;

procedure TmainFrm.LockBufSizeClick(Sender: TObject);
begin
    //锁定缓存
    if (bActive>0) then
        okStopCapture(hBoard);
    SetLockBuffer.ShowModal;
end;

procedure TmainFrm.LoopFromBufferClick(Sender: TObject);
var
   dwTemp:MWORD;
begin
    //（循环）序列回显缓存
    if (BackToScreen.Checked) then
        bDispToScreen := 1
    else
	      bDispToScreen := 0;
    FreezeClick(Sender);
    Freeze.Enabled := TRUE;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    num := okGetBufferSize(hBoard, nil, dwTemp);//
    okPlaybackFrom(hBoard, DLBUFFER, 0, -num); //<0: loop inifintely
end;

procedure TmainFrm.LoopSeqCapToBufClick(Sender: TObject);
begin
    //(循环)中断控制序列采集
    Freeze.Enabled := TRUE;

    if (BackToScreen.Checked = True) then
        bDispToScreen := 1
    else
        bDispToScreen := 0;

    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);

    okCaptureSequence(hBoard, 0, -1);//
end;

procedure TmainFrm.LoopToBufferClick(Sender: TObject);
begin
    //(循环)序列采到缓存
    if (BackToScreen.Checked) then
            bDispToScreen := 1
    else
    	bDispToScreen := 0;

    Freeze.Enabled:=TRUE;
    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);
    okCaptureTo(hBoard,DLBUFFER,0,-1);//-1: loop infiniately
end;

procedure TmainFrm.MakeXMirrorClick(Sender: TObject);
begin
    //水平方向镜象
    if MakeXMirror.Checked then
       bMakeMirror := bMakeMirror And 2
    else
       bMakeMirror := bMakeMirror Or 1;
    MakeXMirror.Checked := Not MakeXMirror.Checked;
    okSetConvertParam(hBoard, CONVERT_MIRROR, bMakeMirror);
end;

procedure TmainFrm.MakeYMirrorClick(Sender: TObject);
begin
    //垂直方向镜象
    if MakeYMirror.Checked then
       bMakeMirror := bMakeMirror And 1
    else
       bMakeMirror := bMakeMirror Or 2;
    MakeYMirror.Checked := Not MakeYMirror.Checked;
    okSetConvertParam(hBoard, CONVERT_MIRROR, bMakeMirror);
end;

procedure TmainFrm.MatchClientClick(Sender: TObject);
begin
    MatchClient.Checked := not MatchClient.Checked;

    if (MatchClient.Checked) then
        CenterScreen.Checked := FALSE;

    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);

    mainFrm.Refresh;
end;

procedure TmainFrm.MulChanCapClick(Sender: TObject);
var
   elapsed:Longint;
   i:Longint;
   dlrect:TRect;
   wid,hei:Integer;
   dlmsg:MSG;
begin
    SetSourceNumBox.ShowModal;
    NoCapture := iNum;
    mainfrm.Caption := ' Any key to stop !';


    dlrect.right := -1;
    okSetTargetRect(hBoard, DLVIDEO, dlrect);
    wid := dlrect.right - dlrect.left;
    hei := dlrect.bottom - dlrect.top;

    dlrect := GetClientRect();
    MapWindowPoints(mainFrm.handle, HWND_DESKTOP, dlrect, 2);
    if(CenterScreen.Checked = True) then
    begin
         if(hei < (dlrect.bottom-dlrect.top)) then
             dlrect.top := dlrect.top + (dlrect.bottom - dlrect.top - hei) Div 2;
         dlrect.left := dlrect.left + max(0, (dlrect.right - dlrect.left - wid) Div 2);
    end;
    okSetTargetRect(hBoard, DLSCREEN, dlrect);

    elapsed := GetTickCount();
    i := 0;
    // fast test multi channel
    while True do
    begin
         okCaptureTo(hBoard, DLSCREEN, 0, 1);
         if(okGetTypeCode(hBoard, nil) <> OK_C30) then //only C30 can switch source immediately
             okGetCaptureStatus(hBoard, True);
         Inc(i);
         okSetVideoParam(hBoard, VIDEO_SOURCECHAN, i Mod NoCapture);

         PeekMessage(dlmsg, mainFrm.Handle, 0, 0, PM_REMOVE);
         //GetMessage(&msg, NULL, 0, 0);
         if((dlmsg.message = WM_KEYDOWN) or
         	(dlmsg.message = WM_LBUTTONDOWN) or
            (dlmsg.message = WM_NCLBUTTONDOWN)) then
            break;
    end;

    okStopCapture(hBoard);

    elapsed := GetTickCount() - elapsed;
    mainfrm.Caption := IntToStr(i) + ' Frames Elapsed ' + IntToStr(elapsed) + ' ms';
end;

procedure TmainFrm.MulChanCapSubClick(Sender: TObject);
var
   elapsed:Longint;
   i:Longint;
   rcVideo:TRect;
   dlrect:TRect;
   lpRect:Array[0..4] of TRect;
   hei:Integer;
   dlmsg:MSG;
begin
    SetSourceNumBox.ShowModal;
    NoCapture := iNum;

    mainFrm.Caption := ' Any key to stop !';
    rcVideo.right := -1;
    okSetTargetRect(hBoard,DLVIDEO, rcVideo);
    hei := rcVideo.bottom - rcVideo.top;

    dlrect := GetClientRect();
    MapWindowPoints(mainFrm.Handle, HWND_DESKTOP, dlrect, 2);

    for i:=0 to  NoCapture-1 do
        lpRect[i] := dlrect;

    if(NoCapture <= 2) then //two rect
    begin
         if(CenterScreen.Checked and (hei<(dlrect.bottom-dlrect.top))) then
         begin
              lpRect[0].top := lpRect[0].top + (dlrect.bottom - dlrect.top - hei) Div 2;
              lpRect[1].top := lpRect[1].top + (dlrect.bottom - dlrect.top - hei) Div 2;
         end;
         lpRect[0].right := (dlrect.left + dlrect.right) Div 2-1;
         lpRect[1].left := (dlrect.left + dlrect.right) Div 2+1;
    end
    else  //4 rect
    begin
         //left-top
         lpRect[0].right := (dlrect.left + dlrect.right) Div 2-1;
         lpRect[0].bottom := (dlrect.top + dlrect.bottom) Div 2-1;

         //right-top
         lpRect[1].left := (dlrect.left + dlrect.right) Div 2+1;
         lpRect[1].bottom := (dlrect.top + dlrect.bottom) Div 2-1;

         //left-bottom
         lpRect[2].right := (dlrect.left+dlrect.right) Div 2-1;
         lpRect[2].top := (dlrect.top+dlrect.bottom) Div 2+1;

         //right-bottom
         lpRect[3].left := (dlrect.left+dlrect.right) Div 2+1;
         lpRect[3].top := (dlrect.top+dlrect.bottom) Div 2+1;

    end;

    elapsed := GetTickCount();
    i := 0;
    // fast test multi channel
    while True do
    begin
         //okSetTargetRect(hBoard, VIDEO, &rcVideo);
         okSetTargetRect(hBoard, DLSCREEN, lpRect[i Mod NoCapture]);
         okCaptureTo(hBoard, DLSCREEN, 0, 1);
         //okCaptureTo(hBoard,BUFFER,i,1);
         //okCaptureTo(hBoard,BUFFER,0,50);
         if(okGetTypeCode(hBoard, nil) <> OK_C30) then //only C30 can switch source immediately
             okGetCaptureStatus(hBoard, True);

         okSetVideoParam(hBoard, VIDEO_SOURCECHAN,i Mod NoCapture);

         PeekMessage(dlmsg, mainFrm.Handle , 0, 0, PM_REMOVE);
         //GetMessage(&msg, NULL, 0, 0);
         if((dlmsg.message = WM_KEYDOWN) or
             (dlmsg.message = WM_LBUTTONDOWN) or
             (dlmsg.message = WM_NCLBUTTONDOWN)) then
             break;
         Inc(i);
    end;

    okStopCapture(hBoard);

    elapsed := GetTickCount() - elapsed;
    mainFrm.Caption := IntToStr(i) + ' Frames Elapsed ' + IntToStr(elapsed) + ' ms';
end;

procedure TmainFrm.NormaInLutClick(Sender: TObject);
begin
    //正向输入查找表
    exFillInputLUT(hBoard, 0);
end;

procedure TmainFrm.NormalLutClick(Sender: TObject);
begin
    //正向输出显示
    exFillOutLUT(hBoard, 0);
end;

procedure TmainFrm.PrgExitClick(Sender: TObject);
begin
  Close;
end;

procedure TmainFrm.PrintPicClick(Sender: TObject);
begin
  //打印图像
  ShowMessage('lazarus 暂不支持');
end;

procedure TmainFrm.RegDevDriverClick(Sender: TObject);
begin
  //安装设备驱动
  okSetNTDriver(1); //mainly for NT4
end;

procedure TmainFrm.ReplayBufferClick(Sender: TObject);
var
   dwTemp:MWORD;
begin
  //回放缓存
  total := Smallint(okGetBufferSize(hBoard, nil, dwTemp));
      	//way 1 fresh image on hWnd by thie function
      	//SetWindowLong(hWnd,GWL_USERDATA,lScrnOffset);
      	//lpDibPlay=okOpenReplayDlg(hBoard, hWnd, BUFFER,total);
      	//way 2 fresh image on hWnd by user
  hwndPlay := okOpenReplayDlgEx(hBoard, dlhWnd, DLBUFFER, total, lpbi^, BYTE(lpdib^));
end;

procedure TmainFrm.ReplayFileClick(Sender: TObject);
var
    filename:String;
begin
  //回放序列文件
  OpenDlg.Filter :='Sequence *.seq|*.seq';
  OpenDlg.Title :='选择一序列文件';
  if (Not OpenDlg.Execute) then Exit;

  filename := ConvertEncoding(OpenDlg.FileName, 'utf8', 'ansi');
  if( Pos('.seq',FileName) =0 ) then
      lNumImage := okLoadImageFile(hboard,LPSTR(FileName),0,DLSCREEN,0,0)
  else
      SetSeqNum.ShowModal;
  //lpDibPlay:=okOpenReplayDlg(hBoard, dlhWnd, TARGET(FileName), NUMINFILE);
  hwndPlay := okOpenReplayDlgEx(hBoard, dlhWnd, TARGET(FileName), lNumImage, lpbi^, BYTE(lpdib^));
end;

procedure TmainFrm.ReplayMemoryClick(Sender: TObject);
var
   num:Integer;
begin
  //回放内存
  num := dwMaxMemSize Div exGetFrameSize(hBoard);
  if (lpbi<>nil) then
      			//lpDibPlay=okOpenReplayDlg(hBoard, hWnd, (TARGET)lpMemory,num);
      hwndPlay := okOpenReplayDlgEx(hBoard, dlhWnd, TARGET(lpMemory), num, lpbi^, BYTE(lpdib^));
end;

procedure TmainFrm.SaveBufferClick(Sender: TObject);
begin
  //存缓存图像文件
  exSaveBufferFile(hBoard);
  mainFrm.Refresh;
end;

procedure TmainFrm.SaveConfigFileClick(Sender: TObject);
var
    filename:String;
begin
    SDlg.DefaultExt := '*.OKF';
    SDlg.Filter := 'Config file for Ok Card  (*.OKF)|*.OKF';
    if  (Not SDlg.Execute()) then Exit;
    filename := ConvertEncoding(SDlg.FileName, 'utf8', 'ansi');
    if (Pos('.', FileName )=0) then Exit;

    okSaveConfigFile(hBoard, LPSTR(FileName));
end;

procedure TmainFrm.SaveScreenClick(Sender: TObject);
begin
    //存屏幕图像文件
    exSaveScreenFile(hBoard);
    mainFrm.Refresh;
end;

procedure TmainFrm.ScreenToBufferClick(Sender: TObject);
begin
    //屏幕传送到缓存0
    okConvertRect(hBoard,DLBUFFER,0,DLSCREEN,0,1);
end;

procedure TmainFrm.SelectCardClick(Sender: TObject);
begin
    //选用图像板
    SelectBox.ShowModal;
end;

procedure TmainFrm.SeqCapToBufClick(Sender: TObject);
var
   num:Longint;
begin
    //中断控制序列采集
    Freeze.Enabled := TRUE;

    num := okCaptureSequence(hBoard, 0, 0); //just get num for sequence

    lNumImage := num;
    if (SetSeqNum.ShowModal <> 0) then
        num := lNumImage;

    if (BackToScreen.Checked = True) then
        bDispToScreen := 1
    else
        bDispToScreen := 0;

    okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);

    okCaptureSequence(hBoard, 0, num);//
end;

procedure TmainFrm.SetAllocBufClick(Sender: TObject);
begin
    BufferDlgBox.ShowModal;
end;

procedure TmainFrm.SetMatchSizeClick(Sender: TObject);
begin
    SetCSize.ShowModal;
    mainFrm.Refresh;
end;

procedure TmainFrm.SetToBandClick(Sender: TObject);
var
   i:Integer;
   lpLinear:LPSTR;
   hei:Smallint;
   wid:Smallint;
   stride,wbytes:MLONG;

   sTemp:Smallint;
begin
    //置条带图像
    //set gray and color bands to dib and buffer 0

    //set dib
    exSetTestBands(lpdib, lpbi^.biBitCount, lpbi^.biHeight, lpbi^.biSizeImage div lpbi^.biHeight);
    exConvertBitmap(lpbi,lpdib);

    lpLinear := okGetTargetInfo(hBoard, DLBUFFER, 0, wid, hei, stride);
    if (lpLinear<>nil) then
    begin
						//	okWriteRectEx(hBoard,BUFFER,0, lpdib,MAKELONG(FORM_RGB888,0)); //just take green when white/balck
							//exSetTestBands(lpLinear,stride/width, height, stride); //buffer
							//exSetDataToDIB(BUFFER, 0, lpbi, lpdib);
    end;

    ZeroMemory(@blk,sizeof(BLOCKINFO));
    //get image to app buffer from tgt
    LPSTR(blk.lpBits) := LPSTR(lpdib);
    blk.iWidth := Smallint(lpbi^.biWidth);
    blk.iHeight := -Smallint(lpbi^.biHeight); //!!!to invert y
    blk.iBitCount := lpbi^.biBitCount;
    blk.lBlockStep := Smallint(lpbi^.biSizeImage); //must be set
    blk.iHiStep := HIWORD(lpbi^.biSizeImage);
    if (lpbi^.biCompression = BI_BITFIELDS) then //
    begin
        LPSTR(lpMask):= LPSTR(lpbi)+ lpbi^.biSize;
	if (lpMask[1] = $03e0) then //555
	    blk.iFormType := FORM_RGB555
	else if(lpbi^.biBitCount = 16) then
	    blk.iFormType := FORM_RGB565
	else if(lpbi^.biBitCount = 32) then
	    blk.iFormType := FORM_RGB8888;
    end;
    okConvertRect(hBoard, DLBUFFER, 0, TARGET(@blk), 0, 1);

    //else {//only dib
    //	exSetTestBands(lpdib, (short)lpbi->biHeight, lpbi->biSizeImage/lpbi->biHeight);
    //}

    //exSetTestBands(hBoard);
    mainFrm.Refresh;
end;

procedure TmainFrm.SetToZeroClick(Sender: TObject);
var
   lpLinear:LPBYTE;
   hei:Smallint;
   stride:MLONG;

   sTemp:Smallint;
begin
    //图像清零
    //clear screen dib and buffer 0
    if (lpbi^.biHeight<>0) then
    	ZeroMemory(lpdib, lpbi^.biSizeImage);
    InvalidateRect(dlhWnd, nil, FALSE);
    lpLinear := okGetTargetInfo(hBoard, DLBUFFER, 0, sTemp, hei, stride);
    ZeroMemory(lpLinear, stride*hei);
end;

procedure TmainFrm.SetupVideoClick(Sender: TObject);
begin
    //参数设置

    //restore interrupt set
		okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,intrMISCCONTROL or
				(okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1) and (not $3)));

    okOpenSetParamDlg(hBoard, mainFrm.WindowHandle);
		//may be initialized
		intrMISCCONTROL := okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1) and $3;

    //dest(buffer) rect may be changed
    exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
    //get current size
    sampwidth := lpbi^.biWidth;
    sampheight := lpbi^.biHeight;
    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    //get current mask mode
    bMaskMode := okEnableMask(hBoard, -1);
    if (bMaskMode<>0) then
        enablemask.Enabled := True
    else
        enablemask.Enabled :=False;

    mainfrm.Refresh;
end;

procedure TmainFrm.SignalInfoClick(Sender: TObject);
begin
    //信号信息
    if(bActive<>0) then
        okStopCapture(hBoard);
    MessageBeep(MB_ICONEXCLAMATION);
    SignalBox.ShowModal;
end;

procedure TmainFrm.SingleCapToClick(Sender: TObject);
var
    basetime,elapse,times,times1,times2,lret:Longint;
    str:String;
begin
    Freeze.Enabled := TRUE;
    if (okGetTypeCode(hBoard, nil) = OK_C70 ) then //to frame						okCaptureTo(hBoard,FRAME,0,1);
    begin
         okGetCaptureStatus(hBoard, True);
         if (okConvertRect(hBoard, DLSCREEN, 0, DLFRAME, 0, 1) > 0) then
         begin
             //take buffer size
	     exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
	     exSetDataToDIB(DLSCREEN, 0, lpbi, LPBYTE(lpdib));
         end;
    end
    else
    begin
        str := '';
	lret := okSetCaptureParam(hBoard, CAPTURE_TRIGCAPTURE, -1);
	if( LOWORD(lret)>0 ) then
		str := ' Triggered capture mode!   Now waiting for trigger ...'
	else
        begin
		lret := okSetVideoParam(hBoard,VIDEO_SIGNALTYPE,-1);
		if (HIWORD(lret) <> 0) then
			str := ' Video by external trigger!   Now waiting for video of next frame ...';
        end;

	if (str <> '') then
		mainFrm.Caption := str;


	basetime := okGetTickCount();
	//okCaptureTo(hBoard,SCREEN,0,1);//single
	//okCaptureSingle(hBoard,BUFFER,0);//single
	okCaptureTo(hBoard,DLBUFFER,0,1);//single
	//okCaptureSequence(hBoard,0,1);//single
	elapse := okGetTickCount();
	//okCaptureSequence(hBoard,0,1);//single
	okGetCaptureStatus(hBoard, TRUE);
	times := okGetTickCount();
	//okSleep(20);

	//buf->scr
	exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
	exSetDataToDIB(DLBUFFER, 0, lpbi, LPBYTE(lpdib));
	times1 := okGetTickCount();

	lScrnOffset := exSetToWndRectEx(hBoard, mainFrm.WindowHandle, CenterScreen.Checked);
        mainFrm.Refresh;

	times2 := okGetTickCount();
	//okStopCapture(hBoard);

	str := ' Start=' + IntToStr(elapse-basetime) + ' ms,  Capture=' + IntToStr(times-elapse) + ' ms,  Trans=' + IntToStr(times1-times) + ',  Paint=' + IntToStr(times2-times1) + ' ms';
	mainFrm.Caption := str;
    end;
end;

procedure TmainFrm.SyncMulCapClick(Sender: TObject);
var
   lIndex:MLONG;
   i:Integer;
   hei:Integer;
   rect0,rect1:TRect;
   lphBoard:Array[0..5] of HWND;
   dlmsg:MSG;
begin
    SetCardNum.ShowModal;

    NoCapture := iNum;

    for i:=0 to 5 do
            lphBoard[i] := 0;

    //open specified board
    for i:=0 to NoCapture-1 do
    begin
         lIndex:=i;
         lphBoard[i]:=okOpenBoard(lIndex);
         if(lphBoard[i]=0) then
             break;
    end;
    NoCapture:=i;

    if( NoCapture <>0) then //if success at min. 1 more
    begin
         Freeze.Enabled := True;

         mainFrm.Caption :=' Any key to stop !';

         rect0.right:=-1;
         okSetTargetRect(lphBoard[0],DLVIDEO, rect0);
         hei:=rect0.bottom-rect0.top;

         rect0:=GetClientRect();
         MapWindowPoints(mainFrm.Handle ,HWND_DESKTOP,rect0,2);

         if(NoCapture<=2) then //two rect
         begin
              if( CenterScreen.Checked and (hei<(rect0.bottom-rect0.top)) ) then
                  rect0.top:=rect0.top+(rect0.bottom-rect0.top-hei) Div 2;
              rect1:=rect0;
              rect0.right:=(rect0.right+rect0.left) Div 2-1;
              okSetTargetRect(lphBoard[0], DLSCREEN, rect0);

              rect1.left:=(rect1.right+rect1.left) Div 2+1;
              okSetTargetRect(lphBoard[1], DLSCREEN, rect1);
         end
         else
         begin //4 rect
               rect1:=rect0;
               //left-top
               rect1.right:=(rect0.left+rect0.right) Div 2;
               rect1.bottom:=(rect0.top+rect0.bottom) Div 2;
               okSetTargetRect(lphBoard[0], DLSCREEN, rect1);
               //right-top
               rect1.left:=(rect0.left+rect0.right) Div 2+1;
               rect1.right:=rect0.right;
               okSetTargetRect(lphBoard[1], DLSCREEN, rect1);
               //left-bottom
               rect1.left:=rect0.left+1;
               rect1.right:=(rect0.left+rect0.right) Div 2;
               rect1.top:=(rect0.top+rect0.bottom) Div 2+1;
               rect1.bottom:=rect0.bottom;
               okSetTargetRect(lphBoard[2], DLSCREEN, rect1);
               //right-bottom
               rect1.left:=(rect0.left+rect0.right) Div 2+1;
               rect1.right:=rect0.right;
               okSetTargetRect(lphBoard[3], DLSCREEN, rect1);
         end;

         Sleep(40);
         //start mul-capture
         okMulCaptureTo(lphBoard[0], DLSCREEN, 0, 0);

         while True do
         begin
              //PeekMessage(&msg, NULL, 0, 0, PM_REMOVE);
              GetMessage(dlmsg, mainFrm.Handle , 0, 0);
              if( (dlmsg.message=WM_KEYDOWN) or
                  (dlmsg.message=WM_LBUTTONDOWN) or
                  (dlmsg.message=WM_NCLBUTTONDOWN) ) then
                  break;
         end;

         for i:=0 to NoCapture-1 do
         begin
              okStopCapture(lphBoard[i]);
              //close specified board
              okCloseBoard(lphBoard[i]);
         end;

         okUnlockAllBuffer();

         mainFrm.Caption :=' Stoped !';
    end;
end;

procedure TmainFrm.TestDrawWndClick(Sender: TObject);
var
        dlrect:TRect;
begin
    FreezeClick(Sender);
    Freeze.Enabled := True;
    bActive := -1;
    //must not to upright
    UptoRight.Checked := FALSE;
    UptoLeft.Checked := FALSE;
    okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright

    //okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,1);

    //direct to wnd client
    if(MatchClient.Checked) then
    begin
	//
	//GetClientRect(hWnd,&rect);
	//okSetTargetRect(hBoard,(TARGET)hWnd,&rect);
	//auto matching mode:
	dlrect.left := 1;dlrect.right := 0; //to match window client
	dlrect.top := 0;dlrect.bottom := 0;
        okSetTargetRect(hBoard, TARGET(dlhWnd), dlrect);
    end
    else  //same as set as screen
    begin
	//not matching mode: way 1 to take screen rect preset
	//okSetTargetRect(hBoard,(TARGET)hWnd,NULL); //clear rect set

	dlrect.left := 0; dlrect.right := 0; //not to match window client
	//not matvhing mode: way 2
	//rect.right=-1;
	//okSetTargetRect(hBoard,(TARGET)SCREEN, &rect);
	//MapWindowPoints(HWND_DESKTOP, hWnd, (LPPOINT)&rect,2);
    end;
    if (BackToScreen.Checked) then
	okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);

    okCaptureByBuffer(hBoard, TARGET(dlhWnd), 0, 0);//0: cont.
end;

procedure TmainFrm.TestMainWndClick(Sender: TObject);
begin
    FreezeClick(Sender);
    Freeze.Enabled := TRUE;
    bActive := -1;
    if (BackToScreen.Checked) then
        bDispToScreen := 1
    else
	bDispToScreen := 0;

    hLoopThread := exCreateLoopCapture(hBoard, dlhWnd);
end;

procedure TmainFrm.TestVGACardClick(Sender: TObject);
begin
    FreezeClick(Sender);
    Freeze.Enabled := True;
    bActive := 1;
    //must not to upright
    UptoRight.Checked := FALSE;
    UptoLeft.Checked := FALSE;
    okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to upright

    //restore to normal (system palette)
    //okSetConvertParam(hBoard, CONVERT_PALETTE, (LPARAM)NULL);
    //direct to vga memory
    if (BackToScreen.Checked) then
	okSetSeqCallback(hBoard, @exBeginCapture, @exBackDisplay, @exEndCapture);

    //okSetToWndRect(hBoard,hWnd);
    lScrnOffset := exSetToWndRectEx(hBoard, dlhWnd, CenterScreen.Checked);
    //okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,0);
    okCaptureByBuffer(hBoard, DLSCREEN, 0, 0);//0: cont.
    //{
    //	RECT	rect;
    //	GetClientRect(hWnd,&rect);
    //	okSetTargetRect(hBoard,(TARGET)hWnd,&rect);
    //}
    //okCaptureByBuffer(hBoard,(TARGET)hWnd,0,0);//0: cont.
end;

procedure TmainFrm.UpToLeftClick(Sender: TObject);
var
        bChange:Smallint;
        temp:Longint;
begin
    bChange := 1;

    if (UptoRight.Checked = TRUE) then
    begin
    	UptoRight.Checked := FALSE;
    	UptoLeft.Checked := TRUE;
    	okSetConvertParam(hBoard, CONVERT_UPRIGHT, 2); //to left
    	bChange := 0;
    end
    else
            if (UptoLeft.Checked = TRUE) then
            begin
    	        UptoLeft.Checked := FALSE;
    	        okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to
            end
            else  //new check
            begin
    	        UptoLeft.Checked := TRUE;
    	        okSetConvertParam(hBoard, CONVERT_UPRIGHT, 2); //up to left
            end;

    if (bChange <> 0) then //exchange w and h
    begin //treat rotate
    	temp := lpbi^.biWidth;

    	lpbi^.biWidth := lpbi^.biHeight;
    	lpbi^.biHeight := temp;
    	exSetBitmapHeader(lpbi, short(lpbi^.biWidth), short(lpbi^.biHeight), short(lpbi^.biBitCount), 0);
    end;
    InvalidateRect(dlhWnd, nil, TRUE);
end;

procedure TmainFrm.UpToRightClick(Sender: TObject);
var
        bChange:Smallint;
        temp:Longint;
begin
    bChange := 1;
    if (UptoLeft.Checked = TRUE) then
    begin
    	UptoLeft.Checked := FALSE;
    	UptoRight.Checked := TRUE;
    	okSetConvertParam(hBoard, CONVERT_UPRIGHT, 1); //to right
    	bChange := 0;
    end
    else
            if (UptoRight.Checked = TRUE) then
            begin
    	        UptoRight.Checked := FALSE;
    	        okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un to
            end
            else  //new check
            begin
    	        UptoRight.Checked := TRUE;
    	        okSetConvertParam(hBoard, CONVERT_UPRIGHT, 1); //up to right
            end;

    if (bChange <> 0) then  //exchange w and h
    begin //treat rotate
    	temp := lpbi^.biWidth;

    	lpbi^.biWidth := lpbi^.biHeight;
    	lpbi^.biHeight := temp;
    	exSetBitmapHeader(lpbi, short(lpbi^.biWidth), short(lpbi^.biHeight), short(lpbi^.biBitCount), 0);
    end;
    InvalidateRect(dlhWnd, nil, TRUE);
end;

procedure TmainFrm.ZeroAllBufferClick(Sender: TObject);
var
   lpLinear:LPBYTE;
   dwSize:MWORD;
begin
    //clear screen dib and buffer 0

    //okGetAvailBuffer(&lpLinear,&dwSize);
    okGetBufferSize(hBoard, @lpLinear, dwSize);
    ZeroMemory(lpLinear, dwSize);

    if (lpbi^.biHeight <> 0) then
       ZeroMemory(lpdib, lpbi^.biSizeImage);
    InvalidateRect(dlhWnd, nil, FALSE);
end;

function TmainFrm.exGetInitSet:Boolean;
var
   bMatchClient:Integer;
   bScrnCenter:Integer;
begin
     bScrnCenter := GetPrivateProfileInt('Init', 'Centerize', 1, 'OkDemo.ini');
     if bScrnCenter<>0 then
         CenterScreen.Checked := True
     else
         CenterScreen.Checked := False;

     bMatchClient := GetPrivateProfileInt('Init', 'MatchClient', 0, 'OkDemo.ini');
     if bMatchClient=1 then
         MatchClient.Checked := True
     else
         MatchClient.Checked := False;

     iClientWidth := GetPrivateProfileInt('Init', 'ClientWidth', 0, 'OkDemo.ini');
     iClientHeight := GetPrivateProfileInt('Init', 'ClientHeight', 0, 'OkDemo.ini');

     Result := CenterScreen.Checked;
end;

function TmainFrm.exOpenCard(dlhWnd:HWND):HWND;
var
   iNoBoards:Integer;
   error:Longint;
   p:Pointer;
begin
     //打开图像卡

     //check ok boards sloted in PC
     iNoBoards := okGetImageDevice(LPOKDEVTYPE(p), 0);

     //check if pre_allocated buffer
     okGetAvailBuffer(p, dwBufSize);
     //okGetBufferSize(hBoard,NULL,&dwBufSize);//

     //check if reg device driver for nt/2k/xp
     if (okSetNTDriver(0) = 0) then // TRUE:registered already, -1:not nt system
     	 ShowMessage('There are not yet registered device service driver!')
     else
         if (okSetNTDriver(0) = -1) then //win95/98
         begin
      	if ((iNoBoards = 0) and (okSetStaticVxD(0) = False)) then
                   ShowMessage('There are not yet registered vxd device driver!');
         end
	 else
             if (dwBufSize = 0) then //may be not reg driver, or no board, ...
                ShowMessage('There are no buffer pre-allocated !');

     //just starting, then allocated memory for dib
     if (lpbi = nil) then
     begin
	//GlobalMemoryStatus(Status);

	//determaine how many memory will be allocated as user memory
	//dwMaxMemSize := Status.dwTotalPhys - dwBufSize - 32 * (1 Shl 20); //I'd keep 32M for window system
	//if (dwMaxMemSize <= 0) then
	//	dwMaxMemSize := 5 * (1 Shl 20) //5M
        //else
	//    if (dwMaxMemSize > Status.dwAvailPhys) then
	//	dwMaxMemSize := (dwMaxMemSize + Status.dwAvailPhys) Div 2;

	//if (dwMaxMemSize < 5*(1 Shl 20)) then //need 5M at least for user memory
	//	dwMaxMemSize := Max(5*(1 Shl 20), Status.dwAvailPhys);

	dwMaxMemSize := (10 * (1 shl 20)); //10M
	exAllocateDIBMemory(dwMaxMemSize);
     end;

     hBoard := okOpenBoard(iCurrUsedNo);
     if( hBoard = 0 ) then
     begin //set
           error := okGetLastError();
           if (error = ERR_NOTFOUNDBOARD)  then
               ShowMessage('Not found Ok series Image Board !')
           else if (error = ERR_NOTFOUNDVXDDRV) then
               ShowMessage('Not found VxD driver for Ok series Image Board !')
           else
               ShowMessage('Open selected board failed!');
           Result:=0;
           Exit;
     end;

     InitSetMenu(hBoard);

     Result := hBoard;
end;

function TmainFrm.InitSetMenu(hBoard:HWND):Boolean;
var
    typecode:Longint;
    lset:Longint;
begin
    intrMISCCONTROL := okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1) and $3;

    exGetBitmapHeader(hBoard, DLSCREEN, lpbi);
    //set initial size
    sampwidth := Smallint(lpbi^.biWidth);
    sampheight := Smallint(lpbi^.biHeight);
    //initailize screen
    lScrnOffset := exSetToWndRectEx(hBoard, mainFrm.WindowHandle, CenterScreen.Checked);
    mainFrm.Invalidate;

    okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //init to normal
    UptoRight.Checked := FALSE;
    UptoLeft.Checked := FALSE;

    okSetConvertParam(hBoard, CONVERT_MIRROR, 0);//init to normal
    MakeXMirror.Checked := FALSE;
    MakeYMirror.Checked := FALSE;

    typecode := okGetTypeCode(hBoard, nil);
    if (okSetVideoParam(hBoard, VIDEO_FRAMELINES, -1) <> -1) then //support playback
    begin
        DispMenu.Enabled := TRUE;

	if ((okFillOutLUT(hBoard, nil, 0, 0) <=0) or (typecode = OK_M30)) then//special for M30 without outlut
        begin
             NormalLut.Enabled := False;
             InverseLut.Enabled := False;
             AbsoluteLut.Enabled := False;
             AbsoluteDsa.Enabled := False;
        end;
    end
    else
        DispMenu.enabled := FALSE;

    if( okFillInputLUT(hBoard, nil, 0, 0)<=0 ) then
    begin
        NormalLut.Enabled := False;
        InverseLut.Enabled := False;
  	end
	  else
    begin
        NormalLut.Enabled := True;
        InverseLut.Enabled := True;
	  end;

	  //
	  if ((okFillInputLUT(hBoard, nil, 0, 0)>0) or (okFillOutLUT(hBoard, nil, 0, 0)>0)) then   //set in &out lut
		    FillInGLut.Enabled := True
	  else
		    FillInGLut.Enabled := False;


    if (LOWORD(okSetCaptureParam(hBoard, CAPTURE_FRMRGBFORMAT, -1)) <> $ffff ) then
    begin
         CapToFrame.Enabled := TRUE;
         BufferToFrame.Enabled := TRUE;
         FrameToBuffer.Enabled := TRUE;
         FrameToScreen.Enabled := TRUE;
    end
    else
    begin
         CapToFrame.Enabled := FALSE;
         BufferToFrame.Enabled := FALSE;
         FrameToBuffer.Enabled := FALSE;
         FrameToScreen.Enabled := FALSE;
    end;

    if (typecode = OK_M60) then //special for M60
    begin
         CapToFrame.Enabled := True;
         BUFFERTOFRAME.Enabled := True;
    end
    else
    if (typecode = OK_RGB30) then
    begin
         CAPTOFRAME.Enabled := True;
         FRAMETOBUFFER.Enabled := True;
         FRAMETOSCREEN.Enabled := True;
    end;

    if (okOpenAudio(hBoard, 1) <> 0) then //support audio funcrion
	      CaptureAudio.Enabled := True
    else
	      CaptureAudio.Enabled := False;
    if (okOpenStream(hBoard, 1) <> 0) then //support stream funcrion
      	CaptureMpeg2.Enabled := True
    else
	      CaptureMpeg2.Enabled := False;

    //reg device driver for nt/2k/xp
    if (okSetNTDriver(0) <> 0)  then// TRUE:registered already, -1:not nt system
       RegDevDriver.Enabled  := False;

    bMaskMode := okEnableMask(hBoard, -1);
    if (bMaskMode = -1) then//not support
        enablemask.Enabled := False
    else
    begin
         enablemask.Enabled := True;
         if (bMaskMode <> 0) then//
            enablemask.Checked := True
         else
             enablemask.Checked := False;

         exDemoMask(hBoard, bMaskMode);
    end;

    if (okCaptureSequence(hBoard, 0, 0) = -1) then
    begin
        SeqCapToBuf.Enabled  := False;
	InterToIndirect.Enabled := False;
    end
    else
    begin
        SeqCapToBuf.Enabled  := True;
	LoopSeqCapToBuf.Enabled := True;
	InterToIndirect.Enabled := True;
    end;

    //disable active and display sync with vert
    lset := okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1);
    //if(MF_CHECKED==LOWORD(GetMenuState(hMenu,IDM_DISABLEACTIVE,MF_BYCOMMAND)))
    if (((lset and $800000) = $800000) or ((lset and $80) = $80)) then //disabled
	  DisableActive.Checked := True
    else
	  DisableActive.Checked := False;


    lset := okSetConvertParam(hBoard,CONVERT_NOSYNCSCREEN,-1); //0: sync
    if (lset <> 0) then //disabled
	  DisableSyncVert.Checked := TRUE
    else
	  DisableSyncVert.Checked := FALSE;

    Result := True;
end;

function TmainFrm.exGetBitmapHeader(hBoard:HWND; src:TARGET; lpbi:PBITMAPINFOHEADER):Boolean;
var
   wid,hei:Smallint;
   form,extend:Longint;
   temp:short;
begin
     form := exGetTargetSize(hBoard, src, wid, hei);
     extend := okSetCaptureParam(hBoard, CAPTURE_SAMPLEFIELD, -1);
     if (extend = 0) then //in field
     begin
         extend := okSetConvertParam(hBoard,CONVERT_FIELDEXTEND,-1);
         if ((extend = FIELD_COPYEXTEND) or (extend = FIELD_COPYINTERPOL))
         then
         begin
	     hei := hei * 2;
         end;
     end;

     //here take form as screen forever
     if (src <= 1) then
          form := okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1

     temp := short(okSetConvertParam(hBoard,CONVERT_UPRIGHT,-1)); //un
     if (temp>0) then
     begin
        temp := wid;
	wid := hei;
	hei := temp;
     end;

     exSetBitmapHeader(lpbi, wid, hei, HIWORD(form), LOWORD(form) );

     if LOWORD(form)<>0 then
         Result:=True
     else
         Result:=False;
end;

//--demo to mask some areas just for those cards with masking capablilty
function exDemoMask(hBoard:HWND; bMaskMode:Smallint):Boolean;
var
    i:Integer;
    dlrect:TRect;
    lpMask:Array[0..40960] of BYTE;
    lfLogFont:TLOGFONT;
    textmode:SETTEXTMODE;

    hDCBitmap:HWND;
    hdcMem:HDC;

    pt0, pt1:TPoint;
    oldGraph:Longint;
    lpGraph:LPBYTE;
    wid,ht:Short;
    stride:MLONG;
    rcRect:TRect;
begin
    ZeroMemory(@lfLogFont, sizeof(lfLogFont));
    lfLogFont.lfHeight := -20;
    lfLogFont.lfWeight := 400;
    lfLogFont.lfOutPrecision := 1;
    lfLogFont.lfClipPrecision := 2;
    lfLogFont.lfClipPrecision := 1;
    lfLogFont.lfPitchAndFamily := 26;
    StrCopy(lfLogFont.lfFaceName, 'Arial');

    //1.------ overlay graph--------------------------------------------------------
    //set graph overlay
    SetRect(dlrect, 0, 0, 0, 0);	 //set characters
    //SETTEXTMODE	textmode={0xffffff,0x0,COPYFONT,0,0};  //
    textmode.dwForeColor := $ffffff;
    textmode.dwBackColor := 0;
    textmode.dwSetMode := FULLCOPY;
    textmode.wFrameNo := 0;
    textmode.wGroupNo := 0;

    pt0.X := 100;
    pt0.Y := 20;
    pt1.X := 200;
    pt1.Y := 120;

    oldGraph := okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, -1);

    rcRect.right := -1;
    okSetTargetRect(hBoard, DLBUFFER, rcRect);

    rcRect.left := rcRect.left - 100; rcRect.top := rcRect.top - 100;
    rcRect.right := rcRect.right + 100; rcRect.bottom := rcRect.bottom + 100;

    //okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x803);
    //select cap-graph frm0
    okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, $003);
    lpGraph := okGetTargetInfo(hBoard, DLGRAPH, 0, wid, ht, stride);
    if (lpGraph <> nil) then //clear
	ZeroMemory(lpGraph, stride*ht);// ZeroMemory

    okFillCircleTo(hBoard, DLGRAPH, 0, rcRect, 1, 0);
    okSetTextTo(hBoard, DLGRAPH, rcRect, lfLogFont, textmode, ' JOINHOPE嘉恒中自', 16);
    //okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1);
    okDrawLineTo(hBoard, DLGRAPH,0,pt0,pt1,$ff);
    SetRect(dlrect, 200, 120, 200, 120);
    okSetTextTo(hBoard, DLGRAPH, dlrect, lfLogFont, textmode, ' 嘉恒中自JOINHOPE', 16);

    //select cap-graph frm1
    okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, $203);
    if (lpGraph <> nil) then //clear
	ZeroMemory(lpGraph, stride*ht);// ZeroMemory

    okFillCircleTo(hBoard, DLGRAPH, 0, rcRect, 1, 0);
    SetRect(dlrect,0,0,0,0);
    okSetTextTo(hBoard, DLGRAPH, dlrect, lfLogFont, textmode, ' JOINHOPE嘉恒中自', 16);
    //okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1);
    okDrawLineTo(hBoard, DLGRAPH, 0, pt0, pt1, $ff);
    SetRect(dlrect, 200, 120, 200, 120);
    okSetTextTo(hBoard, DLGRAPH, dlrect, lfLogFont, textmode, ' 嘉恒中自JOINHOPE', 16);

    //----------------------------------------------------------
    //select out-graph frm0
    okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, $103);
    if (lpGraph <> nil) then //clear
	ZeroMemory(lpGraph, stride*ht);// ZeroMemory

    okFillCircleTo(hBoard, DLGRAPH, 0, rcRect, 1, 0);
    SetRect(dlrect, 0, 0, 0, 0);
    okSetTextTo(hBoard, DLGRAPH, dlrect, lfLogFont, textmode, ' JOINHOPE嘉恒中自', 16);
    //okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1);
    okDrawLineTo(hBoard, DLGRAPH, 0, pt0, pt1, $ff);
    SetRect(dlrect, 200, 120, 200, 120);
    okSetTextTo(hBoard, DLGRAPH, dlrect, lfLogFont, textmode, ' 嘉恒中自JOINHOPE', 16);


    //select out-graph frm1
    okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, $303);
    if (lpGraph <> nil) then //clear
	ZeroMemory(lpGraph, stride*ht);// ZeroMemory

    okFillCircleTo(hBoard, DLGRAPH, 0, rcRect, 1, 0);
    SetRect(dlrect, 0, 0, 0, 0);
    okSetTextTo(hBoard, DLGRAPH, dlrect, lfLogFont, textmode, ' JOINHOPE嘉恒中自', 16);
    //okSetTextTo(hBoard, (TARGET)GRAPH, &rect, &lfLogFont, &textmode, "H", 1);
    okDrawLineTo(hBoard, DLGRAPH, 0, pt0, pt1, $ff);
    SetRect(dlrect, 200, 120, 200, 120);
    okSetTextTo(hBoard, DLGRAPH, dlrect, lfLogFont, textmode, ' 嘉恒中自JOINHOPE', 16);


    //okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, 0x003); //enable both graph overlay
    okSetVideoParam(hBoard, VIDEO_ENABLEGRAPHS, oldGraph); //restore




    //2.------ mask graph--------------------------------------------------------
    ZeroMemory(@textmode, sizeof(textmode));
    textmode.dwBackColor := $ffffff;
    textmode.dwSetMode := 2;

    //1. way (to set whole rect to enable/disable)
    //graph 1.
    dlrect.left := 200;
    dlrect.top := 100;
    dlrect.right := 280;
    dlrect.bottom := 180;
    okSetMaskRect(hBoard, dlrect, LPSTR(0)); //disable Big Rect video
    InflateRect(dlrect, -20, -20);
    okSetMaskRect(hBoard, dlrect, LPSTR(1)); //enable Small Rect video

    //graph 2.
    SetRect(dlrect, 0, 200, 200, 201);
    okSetMaskRect(hBoard, dlrect, LPSTR(0));  //D ---
    SetRect(dlrect, 0, 202, 200, 203);
    okSetMaskRect(hBoard, dlrect, LPSTR(0));  //D ---
    SetRect(dlrect, 0, 205, 200, 206);
    okSetMaskRect(hBoard, dlrect, LPSTR(0));  //D ---



    //2. way (to set mask rect with each pixel setting)

    //graph 3.
    ZeroMemory(@lpMask[0], 20000); //clear bits
    for i:=20 to 79 do
	      lpMask[100+i] := 1;		//E ~~~

    for i:=1 to 98 do
	      lpMask[100*50+i] := 1;		//E ---
    for i:=1 to 98 do
	      lpMask[i*100+50] := 1;		//E  |

    for i:=0 to 98 do
	      lpMask[i*100+i] := 1;		//E  /
    SetRect(dlrect, 10, 310, 110, 410); //Disable Rect with + \ ~
    okSetMaskRect(hBoard, dlrect, LPSTR(@lpMask[0]));

    //graph 4.
    FillMemory(@lpMask[0], 40000, 1); //set bits
    for i:=1 to 98 do
	      lpMask[5000+i] := 0;		//D ---
    for i:=1 to 98 do
	      lpMask[i*100+50] := 0;		//D  |
    SetRect(dlrect, 200, 319, 300, 419);	 //disable +
    okSetMaskRect(hBoard, dlrect, LPSTR(@lpMask[0]));


    //example to set char
    SetRect(dlrect, 0, 0, 0, 0);

    FillMemory(@lpMask[0], 40000, 1); //set bits to init
    blk.lpBits := @lpMask[0];
    blk.iBitCount := 8;
    blk.iWidth := 100;
    blk.iHeight := 30;
    okSetTextTo(hBoard, TARGET(@blk), dlrect, lfLogFont, textmode, '嘉恒中自', 8);

    SetRect(dlrect, 300, 200, 300+100, 200+30);	 //set characters
    okSetMaskRect(hBoard, dlrect, LPSTR(@lpMask[0]));

    FillMemory(@lpMask[0], 40000, 1); //set bits to init
    SetRect(dlrect, 0, 0, 0, 0);	 //set characters
    okSetTextTo(hBoard, TARGET(@blk), dlrect, lfLogFont, textmode, 'JoinHope', 8);
    SetRect(dlrect, 300, 240, 300+100, 240+30);	 //set chinese characters
    okSetMaskRect(hBoard, dlrect, LPSTR(@lpMask[0]));

    //example to set char and graphics by way of windows hdc

    FillMemory(@lpMask[0], 40000, 1); //set bits to init
    blk.lpBits := @lpMask[0];
    blk.iBitCount := 8;
    blk.iWidth := 200;
    blk.iHeight := 100;

    hdcMem := okCreateDCBitmap(hBoard, TARGET(@blk), hDCBitmap);

    SetTextColor(hdcMem, $ffffff); //cf
    SetBkColor(hdcMem, 0); //cf
    TextOut(hdcMem, 100, 0, '7123456', 7);
    MoveToEx(hdcMem, 100, 100, nil);
    LineTo(hdcMem, 200, 500);
    Ellipse(hdcMem, 0, 0, 200, 100);

    okMapDCBitmapTo(hDCBitmap, 0);

    okFreeDCBitmap(hDCBitmap);

    SetRect(dlrect, 0, 0, 200, 100);
    okSetMaskRect(hBoard, dlrect, LPSTR(@lpMask[0]));

    //turn on mask
    okEnableMask(hBoard, bMaskMode); //1 positive mask
    //okEnableMask(hBoard,2); //2 negtive mode

    Result:=True;
end;

//--demo to set current capture rect on screen. mode=0: left-top, 1:centerize
function TmainFrm.exSetToWndRectEx(hBoard:HWND; dhWnd:HWND; lMode:Boolean):Longint;
var
   lSize:Longint;
   dlrect:TRect;
   wid,hei:Smallint;
begin
     if Not IsWindow(dlhWnd) then
     begin
          Result := 0;
          Exit;
     end;
     if IsIconic(dlhWnd) then
     begin
          Result := 0;
          Exit;
     end;

     //get client rect
     dlrect := GetClientRect();
     okSetToWndRect(hBoard, dlhWnd);

     if lMode then //set to center
     begin
          //get available rect size
          //lSize=okSetVideoParam(hBoard,VIDEO_AVAILRECTSIZE,-1);
          //or set to expected size
          //sampwidth=LOWORD(lSize);
          //sampheight=HIWORD(lSize);
          if (okGetCaptureStatus(hBoard, False) <> 0) then //capturing
          begin
               wid := sampwidth;
               hei := sampheight;
          end
          else
          begin  //frozen status
                 wid := lpbi^.biWidth;
                 hei := lpbi^.biHeight;
          end;
          if dlrect.right > wid then
             dlrect.left := (dlrect.right - width) Div 2  ;//& (~0x3);
          if (dlrect.bottom) > hei then
             dlrect.top := (dlrect.bottom - height) Div 2;
     end;
     //make offset x,y
     lSize := MAKELONG(dlrect.left, dlrect.top);
     dlrect.right := dlrect.left + min(sampwidth, dlrect.right);
     dlrect.bottom := dlrect.top + min(sampheight, dlrect.bottom);

     //map to absolute screen rect
     MapWindowPoints(dlhWnd, HWND_DESKTOP, dlrect, 2);

//     ShowMessage(IntToStr(dlrect.top)+' '+inttostr(dlrect.bottom));
     if MatchClient.Checked = False then //need not to match client rect
         okSetTargetRect(hBoard, DLSCREEN, dlrect);
     Result := lSize;
end;

procedure TmainFrm.exSetPaletteToWnd(dlhDC:HWND);
var
   frm:Longint;
   bytes:Smallint;

begin
     //get current screen(VGA) format
     frm:=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
     bytes:=HIWORD(frm); //take HIWORD
     frm:=LOWORD(frm);

     if(bytes=8) then
     begin //gray
           if(dlhPalette=0) then
               dlhPalette := exMakeLogPalette(bytes,Smallint(frm));


           SelectPalette(mainFrm.Canvas.Handle ,dlhPalette,FALSE);
           RealizePalette(mainFrm.Canvas.Handle );     // GDI Bug
     end;
end;

//Make logic palette
function TmainFrm.exMakeLogPalette(iBits:Smallint; rgbForm:Smallint):HPALETTE;
var
   hLogPal:HPALETTE;
   npPal:NPLOGPALETTE;
   nNumColors:WORD;
   i:Smallint;
   red, green, blue:BYTE;
begin
    nNumColors:=WORD(1 Shl iBits);
    npPal := NPLOGPALETTE(LocalAlloc(LMEM_FIXED, sizeof(LOGPALETTE) + nNumColors * sizeof(PALETTEENTRY)));
    if (npPal = nil) then
    begin
         Result:=0;
         Exit;
    end;

    npPal^.palVersion := $300;
    npPal^.palNumEntries := nNumColors;
    //set palette
    if(rgbForm=FORM_RGB332) then //rgb 332
    begin
        red:=0;
        green:=0;
        blue:=0;
	for i := 0  to nNumColors-1 do
        begin
		npPal^.palPalEntry[i].peBlue := blue;
		npPal^.palPalEntry[i].peGreen := green;
		npPal^.palPalEntry[i].peRed := red;
		npPal^.palPalEntry[i].peFlags := 0;
                red:=red+32;
		if (red = 0) then
                begin
                    green:=green+32;
		    if (green <>0) then
		    	blue := blue+64;
                end;
	end;
    end
    else
    begin
		for i := 0 to nNumColors-1 do
                begin
			npPal^.palPalEntry[i].peRed := BYTE(i);
			npPal^.palPalEntry[i].peGreen := BYTE(i);
			npPal^.palPalEntry[i].peBlue := BYTE(i);
			npPal^.palPalEntry[i].peFlags := 0;
		end;
    end;

    hLogPal := CreatePalette(npPal^);
    LocalFree(HWND(npPal));

    Result:=hLogPal;
end;

procedure TmainFrm.exCloseThisBoard(hBoard:HWND);
begin
    //okSetVideoParam(hBoard,VIDEO_BRIGHTNESS,10);
    //okSaveInitParam(hBoard,2);
    SendMessage(hwndPlay,WM_COMMAND,IDCANCEL,0);

    okSetConvertParam(hBoard,CONVERT_UPRIGHT,0); //un
    okSetConvertParam(hBoard,CONVERT_MIRROR,0);

    if (hAudio <> 0) then//audio opened
    begin
	    okCloseAudio(hAudio);
	    hAudio := 0;
    end;
    if (hStream <> 0) then//stream opened
    begin
	    okCloseStream(hStream);
	    hStream := 0;
    end;
    if(hLoopThread <> 0) then
    begin
	    TerminateThread(hLoopThread,0);
	    hLoopThread := 0;
    end;

    //restore interrupt set
    okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,intrMISCCONTROL or
	(okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1) and (not $3)));
    okCloseBoard(hBoard);

    exStopMulCapture(); //to stop in case mul-capturing
end;

procedure TmainFrm.exSaveInitSet;
var
   Buffer:array[0..127] of char;
begin
    if CenterScreen.Checked then
        WritePrivateProfileString('Init', 'Centerize', '1', 'OkDemo.ini')
    else
        WritePrivateProfileString('Init', 'Centerize', '0', 'OkDemo.ini');

    if MatchClient.Checked then
        WritePrivateProfileString('Init', 'MatchClient', '1', 'OkDemo.ini')
    else
        WritePrivateProfileString('Init', 'MatchClient', '0', 'OkDemo.ini');

    StrPCopy(Buffer,IntToStr(bMakeMirror));
    WritePrivateProfileString('Init', 'MakeMirror', buffer, 'OkDemo.ini');

    StrPCopy(Buffer,IntToStr(iClientWidth));
    WritePrivateProfileString('Init', 'ClientWidth', buffer, 'OkDemo.ini');
    StrPCopy(Buffer,IntToStr(iClientHeight));
    WritePrivateProfileString('Init', 'ClientHeight', buffer, 'OkDemo.ini');

end;

function TmainFrm.exStopMulCapture:Integer;
var
   i:Integer;
begin
    if (NoCapture <> 0) then
    begin
        for i:=0 to NoCapture-1 do
	      if (lphBoard[i] <> 0) then
		        okStopCapture(lphBoard[i]);

        okUnlockAllBuffer();

	for i:=0 to NoCapture-1 do
        begin
	      //close specified board
	      if (lphBoard[i] <> 0) then
	          okCloseBoard(lphBoard[i]);
	      lphBoard[i] := 0;
        end;

    end;

    NoCapture := 0; //clear

    Result := 1;
end;

//--demo to set color/gray bands to buffer and dib
function TmainFrm.exSetTestBands(lpLinear:Pointer; bits:Smallint; hei:Smallint; stride:Longint):Boolean;
var
   i,j,k:Integer;
   bwid:Integer;
   offx,offy:Integer;
   halfx:Smallint;
   endx:Smallint;
   step:Smallint;
   ps:^DWORD;
begin
    //set gray and color bands to dib and buffer 0

    //init var
    step := bits div 8;
    bwid := (32 * bits) div 8;
    halfx := stride div 2 div bits * bits;
    endx := stride - step + 1;

    //set bands.  suppose buffer as format of 24 bits

    if (lpLinear = nil) then
    begin
        Result := FALSE;
        exit;
    end;

    for i:=0 to hei - 1 do  //clear whole zero
	    FillMemory(LPSTR(lpLinear) + stride * i, stride, 0);//i);

    offy := min(256, hei div 2);  // down half section (gray level section)
    for i:=offy to hei-1 do
    begin
        FillMemory(LPSTR(lpLinear) + stride * i, stride div 2, i - offy); //left half lines

        k := 0;
        j := stride div 2;
        while(j<stride) do  //right half
        begin
	    if (k = 256) then
	        k := 255;
            FillMemory(LPSTR(lpLinear) + stride * i + j, 24*4, k);  //k is value
            j := j + 24 * 4;
            k := k + 32;
	end;
    end;

	  //for(i=0;i<height;i++)  //clear zero
	  //	for(j=0;j<stride;j+=2) {
	  //		*(WORD *)(lpLinear+stride*i+j)=i+1;
	  //	}


	  //-------------------------------------------------------

    offy := 0;	//up half section (color bands section)
    //1black
    for i:=offy to offy+31 do		//right half lines
    begin
        j := halfx;
        while(j<=endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := 0;
            j := j + step;
        end;
    end;
    offy := i;

    //1black
    offx := 0;
    for i:=0 to min(256, hei div 2) - 1 do 	//left half lines
    begin
        j := offx;
	while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := 0;
            j := j + step;
	end;
    end;

    //2blue
    for i:=offy to offy+31 do
    begin
        j := halfx;
        while(j<endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff;
            j := j + step;
	end;
    end;
    offy := i;

    //2blue
    offx := offx + bwid;
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        j := offx;
	while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff;
            j := j + step;
	end;
    end;

    //3red
    for i:=offy to offy+31 do
    begin
        j := halfx;
	while(j<endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff0000;
            j := j + step;
	end;
    end;
    offy := i;

    //3green
    offx := offx + bwid;
    for i:=0 to min(256, hei div 2) -1 do
    begin
        j := offx;
	while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff00;
            j := j + step;
	end;
    end;

    //4magenta
    for i:=offy to offy+31 do
    begin
        j := halfx;
        while(j<endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff00ff;
            j := j + step;
	end;
    end;
    offy := i;

    //4red
    offx := offx + bwid;
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        j := offx;
        while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff0000;
            j := j + step;
	end;
    end;

    //5green
    for i:=offy to offy+31 do
    begin
        j := halfx;
        while(j<endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff00;
            j := j + step;
        end;
    end;
    offy := i;

    //5cyan
    offx := offx + bwid;
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        j := offx;
        while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ffff;
            j := j + step;
        end;
    end;

    //6cyan
    for i:=offy to offy+31 do
    begin
        j := halfx;
        while(j<endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ffff;
            j := j + step;
        end;
    end;
    offy := i;

    //6magenta
    offx := offx + bwid;
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        j := offx;
        while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ff00ff;
            j := j + step;
        end;
    end;

    //7yellow
    for i:=offy to offy+31 do
    begin
        j := halfx;
        while(j<endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ffff00;
            j := j + step;
        end;
    end;
    offy := i;
    //7yellow
    offx := offx + bwid;
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        j := offx;
        while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ffff00;
            j := j + step;
        end;
    end;

    //8white
    for i:=offy to offy+31 do
    begin
        j := halfx;
        while(j<endx) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ffffff;
            j := j + step;
        end;
    end;
    offy := i;
    //8white
    offx := offx + bwid;
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        j := offx;
        while(j<offx+bwid) do
        begin
            LPSTR(ps) := LPSTR(lpLinear) + stride * i + j;
            ps^ := $ffffff;
            j := j + step;
        end;
    end;

	//repeat
//	offx+=bwid;
//	while(stride/2>offx) {//remain
//		for(i=0;i<min(256,height/2);i++) {
//			memcpy(lpLinear+stride*i+offx,lpLinear+stride*i,stride/2-offx);
//		}
//		offx+=bwid*8;
//	}

    offx := offx + bwid;
    offx := offx + bwid div 2; // blue vertical line
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        LPSTR(ps) := LPSTR(lpLinear) + stride * i + offx;
        ps^ := $ff;
    end;

    offx := offx + bwid div 2; // green vertical line
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        LPSTR(ps) := LPSTR(lpLinear) + stride * i + offx;
        ps^ := $ff00;
    end;

    offx := offx + bwid div 2; //red vertical line
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        LPSTR(ps) := LPSTR(lpLinear) + stride * i + offx;
        ps^ := $ff0000;
    end;

    offx := offx + bwid div 2; //cyan vertical line
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        LPSTR(ps) := LPSTR(lpLinear) + stride * i + offx;
        ps^ := $ffff00;
    end;

    offx := offx + bwid div 2; //magenta vertical line
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        LPSTR(ps) := LPSTR(lpLinear) + stride * i + offx;
        ps^ := $ff00ff;
    end;

    offx := offx + bwid div 2; //yellow vertical line
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        LPSTR(ps) := LPSTR(lpLinear) + stride * i + offx;
        ps^ := $ffff00;
    end;

    offx := offx + bwid div 2; //white vertical line
    for i:=0 to min(256, hei div 2) - 1 do
    begin
        LPSTR(ps) := LPSTR(lpLinear) + stride * i + offx;
        ps^ := $ffffff;
    end;

    //repeat
    offx := offx + bwid;
    while(stride Div 2 > offx) do //remain
    begin
        for i:=0 to min(256, hei Div 2) - 1 do
            CopyMemory(LPSTR(lpLinear)+stride*i+offx,LPSTR(lpLinear)+stride*i,stride Div 2-offx);
        offx := offx + bwid * 8;
    end;


	//set test vert line raster
	//for(i=0;i<height;i++)  //clear zero
	//	FillMemory(lpLinear+stride*i,stride,0);//i);
	//for(j=0;j<stride;j+=3*8) {
	//	for(i=0;i<height;i++) {
	//		*(DWORD *)(lpLinear+stride*i+j)=0xffffff;
	//	}
	//}

	//set test horz line raster
	//for(i=0;i<height;i+=8) {
	//	FillMemory(lpLinear+stride*i,stride,255);
	//}


    Result:=True;
end;

function TmainFrm.exLoadImageFile(hBoard:HWND;dlhWnd:HWND):Boolean;
var
    total:Smallint;
    lNum:Longint;
    length:Longint;
    lParam1:Longint;
    blkinfo:BLOCKINFO;
    extraInfo:EXTRAFRMINFO;
    sRawFile:RAWFILEPARAM;
    filename:String;
begin

    //Get file name
    // fill in non-variant fields of OPENszFileName struct.
    if (Not OpenDlg.Execute) then
    begin
        Result:=False;
        Exit;
    end;

    filename := ConvertEncoding(OpenDlg.FileName, 'utf8', 'ansi');
    if(Pos('.',FileName)=0) then
    begin
        Result:=False;
        Exit;
    end;

    if ((Pos('.seq',FileName)<>0) or (Pos('avi',FileName)<>0)or (Pos('m2v',FileName)<>0)or (Pos('mpg',FileName)<>0)) then
    begin
        //first get inf about seq file
        total:=Smallint(okLoadImageFile(hBoard,LPSTR(FileName),0,TARGET(@blkinfo),0,0));//no=0

	//how many
	lNumImage := total;
	length := total;

        if (SetSeqNum.ShowModal <> 0) then
        begin
	    total := lNumImage;



            //then load them into buffer
            if( okLoadImageFile(hBoard,LPSTR(FileName),0,DLBUFFER,0,total) <>0 ) then
            begin
                //last set first block to dib
		okGetCurrImageInfo(hBoard, Integer(@extraInfo), sizeof(EXTRAFRMINFO));

                exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
                exSetDataToDIB(DLBUFFER, 0, lpbi, LPBYTE(lpdib));
            end;
        end;
    end
    else
    begin
        if (okGetBufferSize(hBoard, nil, dwBufSize) <> 0) then //buffer being
        begin
            //how many
            lNum := 1;
            lParam1 := 0;

	    if (Pos('.raw', FileName) <> 0) then
            begin
                FillMemory(LPSTR(@sRawFile), sizeof(RAWFILEPARAM), 0);
		lParam1 := Longint(@sRawFile);
	    end;

            FillMemory(@blkinfo, sizeof(BLOCKINFO), 0);

	    blkinfo.lpBits := nil; //only get block info
	    if (okLoadImageFile(hBoard, LPSTR(FileName), lParam1, TARGET(@blkinfo), 0, 1) < 0) then
            begin
	        Result := FALSE;
                Exit;
            end;

	    if (sRawFile.wPixBits <> 0) then//filled
	        sRawFile.wRawFlag := RAWFILE;

			      //RAWFILEPARAM RawFile;
			      //if( !stricmp(strrchr(szFileName,'.'),".raw") ){
			      //	RawFile.wRawFlag=RAWFILE;
			      //	RawFile.wPixBits=8;
			      //	RawFile.dwWidth=576;
			      //	RawFile.dwHeight=768;
			      //	RawFile.dwOffset=0;
			      //	lParam1=(long)(&RawFile);
			      //}
			      //okLoadImageFile(hBoard,szFileName,0,SCREEN,0,1); //test


	    //how many
	    lNumImage := lNum;
            if (SetSeqNum.ShowModal <> 0) then
            begin
                lNum := lNumImage;
                //then load them into buffer
                length := okLoadImageFile(hBoard, LPSTR(FileName), lParam1, DLBUFFER, 0, lNum);
                if (length <> 0) then
                begin
		    //buffer size changed
		    if (exAllocateDIBMemory(hBoard) = 0) then
                    begin
                         Result := False;
                         Exit;
                    end;

                    //last set first block to dib
                    exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
                    exSetDataToDIB(DLBUFFER, 0, lpbi, LPBYTE(lpdib));
                end;
            end;
        end
	else
        if (hBoard <> 0) then  //
        begin
            //way 2
            //just load to dib (& screen)
            ZeroMemory(@blkinfo, sizeof(blkinfo)); //zero all for init

            blkinfo.lpBits:=nil; //only get block info
	    okLoadImageFile(hBoard, LPSTR(FileName), 0, TARGET(@blkinfo), 0, 1);

	    // set dib info
	    exGetBitmapHeader(hBoard, TARGET(@blkinfo), lpbi);
	    //buffer size changed
	    if (exAllocateDIBMemory(hBoard) = 0) then
            begin
	        Result := False;
                Exit;
	    end;

            //get dib for wnd paint
            LPSTR(blkinfo.lpBits):=lpdib;
            LPSTR(blkinfo.lpExtra):=LPSTR(lpbi)+lpbi^.biSize;  //do here
            if (okLoadImageFile(hBoard,LPSTR(FileName),0,TARGET(@blkinfo),0,1) <> 0) then
            begin
                 exConvertBitmap(lpbi, lpdib); //invert y
            end;
        end;
    end;

    if (length = 0) then
    	ShowMessage(' Load file failed ?!  Try to check the file or memory size. ');

    Result:=True;
end;

procedure TmainFrm.exSaveScreenFile(hBoard:HWND);
var
   blkinfo:BLOCKINFO;
   lpMask:LPDWORD;
   filename:String;
begin
    //Get file name
    // fill in non-variant fields of OPENszFileName struct.
    if (Not SaveDlg.Execute) then Exit;
    filename := ConvertEncoding(SaveDlg.FileName, 'utf8', 'ansi');
    if( Pos('.',FileName )=0 ) then Exit;

    //save current dib
    blkinfo.iWidth:=Smallint(lpbi^.biWidth);
    blkinfo.iHeight:=Smallint(lpbi^.biHeight);
    blkinfo.iBitCount:=Smallint(lpbi^.biBitCount);
    LPSTR(blkinfo.lpBits):=lpdib;
    LPSTR(blkinfo.lpExtra):=LPSTR(lpbi)+lpbi^.biSize;


    blkinfo.iFormType:=0; //unknown
    //special for 565
    if(lpbi^.biBitCount=16) then
    begin
        LPSTR(lpMask):=LPSTR(blkinfo.lpExtra)+4;

        if (lpMask^=$07e0) then //565
 	    blkinfo.iFormType:=FORM_RGB565
        else
	    blkinfo.iFormType:=FORM_RGB555;
    end;

    //first inverse dib to bitmap
    exConvertBitmap(lpbi, lpdib);
    okSaveImageFile(hBoard,LPSTR(FileName),0,TARGET(@blkinfo),0,1);
    //restore to dib
    exConvertBitmap(lpbi, lpdib);
end;

procedure TmainFrm.exSaveBufferFile(hBoard:HWND);
var
   blkinfo:BLOCKINFO;
   lpMask:LPDWORD;
   dwBuffSize:MWORD;
   lNum:Longint;
   filename:String;
begin

    ZeroMemory(@blkinfo, sizeof(BLOCKINFO));
    //Get file name
    // fill in non-variant fields of OPENszFileName struct.
    if (Not SaveDlg.Execute) then Exit;
    filename := ConvertEncoding(SaveDlg.FileName, 'utf8', 'ansi');

    if (Pos('.',FileName) = 0) then Exit;

    if ((Pos('.seq',FileName)<>0) or (Pos('.avi',FileName)<>0)) then
    begin
        //save buffer seq
        total := Smallint(okGetBufferSize(hBoard, nil, dwBuffSize));
        lNumImage := total;
        SetSeqNum.ShowModal;
        total := lNumImage;
        case (SaveDlg.FilterIndex) of
        4:
            okSaveImageFile(hBoard, LPSTR(FileName + ',jpg,50'), 0, DLBUFFER, 0, total);
        6:
            //Compressed AVI in MJPEG
            okSaveImageFile(hBoard, LPSTR(FileName + ',mjpg,60'), 0, DLBUFFER, 0, total);
        7:
            //Compressed AVI in MPEG4
            okSaveImageFile(hBoard, LPSTR(FileName + ',mpg4'), 0, DLBUFFER, 0, total);
        else
            okSaveImageFile(hBoard, LPSTR(FileName), 0, DLBUFFER, 0, total);
        end;
        //than set this first block to dib to see what we saved
        //exGetBitmapData(hBoard, DLBUFFER, 0, lpbi, lpdib);
        exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
        exSetDataToDIB(DLBUFFER, 0, lpbi, LPBYTE(lpdib));
    end
    else
    begin
        if (okGetBufferSize(hBoard, nil, dwBuffSize) <> 0) then //buffer being
        begin
            lNum := 1;
            SetSeqNum.ShowModal;
            okSaveImageFile(hBoard, LPSTR(FileName), 0, DLBUFFER, 0, lNum);

	    //than set this first block to dib to see what we saved
	    //exGetBitmapData(hBoard, DLBUFFER, 0, lpbi, lpdib);
            exGetBitmapHeader(hBoard, DLBUFFER, lpbi);
            exSetDataToDIB(DLBUFFER, 0, lpbi, LPBYTE(lpdib));
        end
        else
        begin
	    //save current dib
	    blkinfo.iWidth := Smallint(lpbi^.biWidth);
	    blkinfo.iHeight := Smallint(lpbi^.biHeight);

	    blkinfo.lBlockStep := 0;
	    blkinfo.iHiStep := 0;

	    blkinfo.iBitCount := Smallint(lpbi^.biBitCount);
	    LPSTR(blkinfo.lpBits) := lpdib;
	    LPSTR(blkinfo.lpExtra) := LPSTR(lpbi)+lpbi^.biSize;

	    blkinfo.iFormType := 0; //unknown
	    //special for 565
	    if (lpbi^.biBitCount = 16) then
            begin
                LPSTR(lpMask) := LPSTR(blkinfo.lpExtra)+4;
                if (lpMask^=$07e0) then //565
			blkinfo.iFormType := FORM_RGB565
		else
			blkinfo.iFormType := FORM_RGB555;
	    end;
	    //first inverse dib to bitmap
	    exConvertBitmap(lpbi, lpdib);
	    okSaveImageFile(hBoard,LPSTR(FileName), 0, TARGET(@blkinfo), 0, 1);
	    //restore to dib
	    exConvertBitmap(lpbi, lpdib);
        end;
    end;

end;

function TmainFrm.exGetFrameSize(hBoard:HWND):Longint;
var
   bits, size:Longint;
begin
     size:=okSetCaptureParam(hBoard,CAPTURE_BUFBLOCKSIZE,-1);
     bits:=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,-1);
     size:=((HIWORD(bits))Div 8)*LOWORD(size)*HIWORD(size);

     exGetFrameSize := size;
end;

//to open one board as current board to operate
function TmainFrm.exCaptureStreamFile(hBoard:HWND; thWnd:HWND):Boolean;
var
    reslution:Longint;
    filename:String;
begin
    reslution := 0;
    //test audio
    if (Not M2vSaveDlg.Execute) then Exit;
    filename := ConvertEncoding(M2vSaveDlg.FileName, 'utf8', 'ansi');
    if( Pos('.', FileName )=0 ) then Exit;

	  if (hStream = 0) then
        hStream := okOpenStream(hBoard, 0);
    if (hStream <> 0) then
    begin
     	  elapsedtimes := okGetTickCount();

     	  //hwnd=hWnd;

		    reslution := GetPrivateProfileInt('Init', 'StreamResolution', 0, 'OkDemo.ini');

		    okSetStreamParam(hStream, STREAM_RESOLUTION, reslution); //SIF for c20b
		    //okSetStreamParam(hStream, STREAM_BITRATEMODE, 1000); //
		    okSetStreamParam(hStream, STREAM_BITRATEMODE, 3000); //for c20b
		    okSetStreamParam(hStream, STREAM_MAXBITRATE, 9000); //for c20b

		    //okSetStreamParam(hStream, STREAM_BITRATEMODE, 0); //for c20b
		    //okSetStreamParam(hStream, STREAM_MAXBITRATE, 800); //for c20b, errer when small than 800

		    //okSetStreamParam(hStream, STREAM_QUALITY, 50); //for rgb60c

		    //okSetStreamParam(hStream, STREAM_MAXFILELEN, 1); //for c20b

	      //capture audio and create file
	      exCreateStreamFile3(hStream, LPSTR(FileName));

	      //exEnableItem(hwnd, IDM_FREEZE, TRUE);

	      Result := True;

        Exit;

    end;

    Result := False;
end;


end.

