unit Select;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  okapi32;

type

  { TSelectBox }

  TSelectBox = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { private declarations }
    procedure InitDialog;
  public
    { public declarations }
  end;

var
  SelectBox: TSelectBox;
  iVirtCode:short;
  bFind:short;
  bNetFind:short;
  szVirtName:Array[0..30] of char;
  lpBoardInfo:LPOKDEVTYPE;

implementation

uses
    main;

{$R *.lfm}

{ TSelectBox }

procedure TSelectBox.FormCreate(Sender: TObject);
begin
    bFind := 0;
    bNetFind := -1;

    InitDialog;
end;

procedure TSelectBox.ListBox1Click(Sender: TObject);
begin
    iCurrUsedNo:=ListBox1.ItemIndex;
    if(iCurrUsedNo=-1) then
        iCurrUsedNo:=0;
    Label4.Caption :=IntToStr(iCurrUsedNo);
    Edit1.Text := ListBox1.Items.Strings[iCurrUsedNo];
end;

procedure TSelectBox.Button1Click(Sender: TObject);
var
   hOld:HWND;
begin
    //确定
     hOld := hBoard;

     okSetConvertParam(hBoard, CONVERT_UPRIGHT, 0); //un
     okSetConvertParam(hBoard, CONVERT_MIRROR, 0);
     okSetCaptureParam(hBoard, CAPTURE_MISCCONTROL, 0);

     okCloseBoard(hOld);
     hBoard := mainFrm.exOpenCard(dlhWnd);
     bActive := 0;
     Close;
end;

procedure TSelectBox.Button2Click(Sender: TObject);
begin
     //取消
     Close;
end;

procedure TSelectBox.Button3Click(Sender: TObject);
begin
    ListBox1.Items.Clear;

    bFind := 1;
    if (CheckBox1.Checked) then
    begin
  	bFind := bFind or 2;
  	bNetFind := 1;
    end
    else
    begin
        bNetFind := 0;
    end;

    InitDialog;
end;

procedure TSelectBox.InitDialog;
var
   i,total:Integer;
   dlStr:String;
begin
    //total:=okGetSlotBoard(lpBoardInfo);
    total := okGetImageDevice(lpBoardInfo, MLONG(@bFind));

	  if (bNetFind = -1) then //first time
		    bNetFind := bFind And 1;

	  bFind := 0;

    if((iVirtCode=0) and (iCurrUsedNo>=total)) then //one virtual card
        iVirtCode:=okGetTypeCode(hBoard, szVirtName);
    Label3.Caption := IntToStr(total);
    for i:=0 to total-1 do
    begin
         dlStr:='No.'+IntToStr(i)+' :  Type code='+IntToStr(lpBoardInfo[i].iBoardTypeCode)+',  Name='+lpBoardInfo[i].szBoardName;
         ListBox1.Items.Add(dlStr);
    end;
    if(iVirtCode<>0) then
    begin
         dlStr:='Virtual:  Type code='+IntToStr(iVirtCode)+',  Name='+szVirtName;
         ListBox1.Items.Add(dlStr);
    end;

    if(iCurrUsedNo<0) then
	      iCurrUsedNo := 0;
    Label4.Caption := IntToStr(iCurrUsedNo);
    Edit1.Text := ListBox1.Items.Strings[iCurrUsedNo];
end;

end.

